
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static inline void
reset_passwords(void)
{
 this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}


/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a<<8) | b)

static int make_pair(int i1, int i2)
{
  unsigned u1 = i1;
  unsigned u2 = i2;

  if ((u1 > 0xFFFF) || (u2 > 0xFFFF))
    cf_error( "Can't operate with value out of bounds in pair constructor");

  return (u1 << 16) | u2;
}

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

static void
finish_iface_config(struct ospf_iface_patt *ip)
{
  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

static struct static_route *this_srt;



/* Line 189 of yacc.c  */
#line 225 "cf-parse.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     GEQ = 261,
     LEQ = 262,
     NEQ = 263,
     AND = 264,
     OR = 265,
     PO = 266,
     PC = 267,
     NUM = 268,
     ENUM = 269,
     RTRID = 270,
     IPA = 271,
     SYM = 272,
     TEXT = 273,
     PREFIX_DUMMY = 274,
     DEFINE = 275,
     ON = 276,
     OFF = 277,
     YES = 278,
     NO = 279,
     LOG = 280,
     SYSLOG = 281,
     ALL = 282,
     DEBUG = 283,
     TRACE = 284,
     INFO = 285,
     REMOTE = 286,
     WARNING = 287,
     ERROR = 288,
     AUTH = 289,
     FATAL = 290,
     BUG = 291,
     STDERR = 292,
     SOFT = 293,
     CONFIGURE = 294,
     DOWN = 295,
     KERNEL = 296,
     PERSIST = 297,
     SCAN = 298,
     TIME = 299,
     LEARN = 300,
     DEVICE = 301,
     ASYNC = 302,
     TABLE = 303,
     ROUTER = 304,
     ID = 305,
     PROTOCOL = 306,
     PREFERENCE = 307,
     DISABLED = 308,
     DIRECT = 309,
     INTERFACE = 310,
     IMPORT = 311,
     EXPORT = 312,
     FILTER = 313,
     NONE = 314,
     STATES = 315,
     ROUTES = 316,
     FILTERS = 317,
     PASSWORD = 318,
     FROM = 319,
     PASSIVE = 320,
     TO = 321,
     EVENTS = 322,
     PACKETS = 323,
     PROTOCOLS = 324,
     INTERFACES = 325,
     PRIMARY = 326,
     STATS = 327,
     COUNT = 328,
     FOR = 329,
     COMMANDS = 330,
     PREEXPORT = 331,
     GENERATE = 332,
     LISTEN = 333,
     BGP = 334,
     V6ONLY = 335,
     ADDRESS = 336,
     PORT = 337,
     PASSWORDS = 338,
     DESCRIPTION = 339,
     RELOAD = 340,
     IN = 341,
     OUT = 342,
     SHOW = 343,
     STATUS = 344,
     SUMMARY = 345,
     ROUTE = 346,
     SYMBOLS = 347,
     DUMP = 348,
     RESOURCES = 349,
     SOCKETS = 350,
     NEIGHBORS = 351,
     ATTRIBUTES = 352,
     ECHO = 353,
     DISABLE = 354,
     ENABLE = 355,
     RESTART = 356,
     FUNCTION = 357,
     PRINT = 358,
     PRINTN = 359,
     UNSET = 360,
     RETURN = 361,
     ACCEPT = 362,
     REJECT = 363,
     QUITBIRD = 364,
     INT = 365,
     BOOL = 366,
     IP = 367,
     PREFIX = 368,
     PAIR = 369,
     SET = 370,
     STRING = 371,
     BGPMASK = 372,
     BGPPATH = 373,
     CLIST = 374,
     IF = 375,
     THEN = 376,
     ELSE = 377,
     CASE = 378,
     TRUE = 379,
     FALSE = 380,
     GW = 381,
     NET = 382,
     MASK = 383,
     PROTO = 384,
     SOURCE = 385,
     SCOPE = 386,
     CAST = 387,
     DEST = 388,
     LEN = 389,
     DEFINED = 390,
     ADD = 391,
     DELETE = 392,
     CONTAINS = 393,
     RESET = 394,
     PREPEND = 395,
     FIRST = 396,
     LAST = 397,
     MATCH = 398,
     EMPTY = 399,
     WHERE = 400,
     EVAL = 401,
     LOCAL = 402,
     NEIGHBOR = 403,
     AS = 404,
     HOLD = 405,
     CONNECT = 406,
     RETRY = 407,
     KEEPALIVE = 408,
     MULTIHOP = 409,
     STARTUP = 410,
     VIA = 411,
     NEXT = 412,
     HOP = 413,
     SELF = 414,
     DEFAULT = 415,
     PATH = 416,
     METRIC = 417,
     START = 418,
     DELAY = 419,
     FORGET = 420,
     WAIT = 421,
     AFTER = 422,
     BGP_PATH = 423,
     BGP_LOCAL_PREF = 424,
     BGP_MED = 425,
     BGP_ORIGIN = 426,
     BGP_NEXT_HOP = 427,
     BGP_ATOMIC_AGGR = 428,
     BGP_AGGREGATOR = 429,
     BGP_COMMUNITY = 430,
     RR = 431,
     RS = 432,
     CLIENT = 433,
     CLUSTER = 434,
     AS4 = 435,
     ADVERTISE = 436,
     IPV4 = 437,
     CAPABILITIES = 438,
     LIMIT = 439,
     PREFER = 440,
     OLDER = 441,
     MISSING = 442,
     LLADDR = 443,
     DROP = 444,
     IGNORE = 445,
     REFRESH = 446,
     OSPF = 447,
     AREA = 448,
     OSPF_METRIC1 = 449,
     OSPF_METRIC2 = 450,
     OSPF_TAG = 451,
     BROADCAST = 452,
     RFC1583COMPAT = 453,
     STUB = 454,
     TICK = 455,
     COST = 456,
     RETRANSMIT = 457,
     HELLO = 458,
     TRANSMIT = 459,
     PRIORITY = 460,
     DEAD = 461,
     NONBROADCAST = 462,
     POINTOPOINT = 463,
     TYPE = 464,
     SIMPLE = 465,
     AUTHENTICATION = 466,
     STRICT = 467,
     CRYPTOGRAPHIC = 468,
     ELIGIBLE = 469,
     POLL = 470,
     NETWORKS = 471,
     HIDDEN = 472,
     VIRTUAL = 473,
     LINK = 474,
     RX = 475,
     BUFFER = 476,
     LARGE = 477,
     NORMAL = 478,
     STUBNET = 479,
     TOPOLOGY = 480,
     STATE = 481,
     PIPE = 482,
     PEER = 483,
     MODE = 484,
     OPAQUE = 485,
     TRANSPARENT = 486,
     RIP = 487,
     INFINITY = 488,
     PERIOD = 489,
     GARBAGE = 490,
     TIMEOUT = 491,
     MULTICAST = 492,
     QUIET = 493,
     NOLISTEN = 494,
     VERSION1 = 495,
     PLAINTEXT = 496,
     MD5 = 497,
     HONOR = 498,
     NEVER = 499,
     ALWAYS = 500,
     RIP_METRIC = 501,
     RIP_TAG = 502,
     STATIC = 503,
     PROHIBIT = 504
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 146 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  void *g;
  bird_clock_t time;
  struct prefix px;



/* Line 214 of yacc.c  */
#line 532 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 544 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  46
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1590

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  271
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  183
/* YYNRULES -- Number of rules.  */
#define YYNRULES  558
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1047

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   504

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    30,     2,     2,     2,    29,     2,     2,
     261,   262,    27,    25,   267,    26,    24,    28,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   264,   263,
      21,    20,    22,   268,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   269,     2,   270,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   265,     2,   266,    23,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    15,    19,    21,
      27,    33,    35,    37,    39,    41,    43,    44,    46,    48,
      51,    53,    55,    58,    61,    63,    65,    66,    71,    73,
      75,    77,    79,    83,    85,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   107,   111,   116,   119,   120,   122,
     125,   128,   132,   135,   138,   142,   146,   150,   155,   157,
     159,   161,   166,   167,   170,   173,   176,   178,   181,   183,
     184,   186,   187,   190,   193,   196,   199,   202,   205,   209,
     212,   215,   217,   219,   221,   223,   227,   231,   232,   234,
     236,   239,   240,   242,   246,   248,   252,   255,   259,   263,
     267,   268,   272,   274,   276,   280,   282,   286,   288,   290,
     292,   294,   296,   298,   303,   305,   306,   310,   315,   317,
     320,   321,   327,   333,   339,   345,   350,   354,   359,   365,
     367,   368,   372,   377,   382,   383,   386,   390,   394,   398,
     401,   404,   407,   411,   415,   418,   421,   423,   425,   430,
     434,   438,   442,   446,   450,   454,   458,   463,   465,   467,
     469,   470,   472,   476,   480,   484,   488,   493,   498,   503,
     505,   507,   509,   510,   515,   518,   520,   522,   524,   526,
     528,   530,   532,   534,   536,   539,   542,   543,   547,   549,
     553,   555,   557,   559,   562,   566,   569,   574,   575,   581,
     582,   585,   587,   591,   597,   599,   601,   603,   605,   607,
     609,   614,   616,   620,   624,   626,   629,   632,   639,   641,
     645,   646,   651,   655,   657,   661,   665,   669,   672,   675,
     678,   681,   682,   685,   688,   689,   695,   697,   699,   701,
     703,   705,   707,   711,   715,   717,   719,   720,   725,   727,
     729,   731,   733,   735,   737,   739,   741,   743,   747,   751,
     755,   759,   763,   767,   771,   775,   779,   783,   787,   791,
     795,   799,   802,   807,   809,   811,   813,   815,   818,   821,
     825,   829,   836,   840,   844,   848,   852,   859,   866,   873,
     878,   880,   882,   884,   886,   888,   890,   892,   893,   895,
     899,   901,   905,   906,   908,   913,   920,   925,   929,   935,
     941,   946,   953,   957,   960,   966,   972,   981,   990,   999,
    1002,  1006,  1010,  1016,  1023,  1030,  1035,  1040,  1046,  1053,
    1060,  1066,  1073,  1079,  1085,  1091,  1097,  1103,  1109,  1115,
    1121,  1127,  1134,  1141,  1150,  1157,  1164,  1170,  1175,  1181,
    1186,  1192,  1197,  1200,  1204,  1208,  1210,  1213,  1216,  1219,
    1223,  1226,  1227,  1231,  1235,  1238,  1243,  1246,  1249,  1251,
    1256,  1258,  1260,  1261,  1265,  1268,  1271,  1274,  1279,  1281,
    1282,  1286,  1287,  1290,  1293,  1297,  1300,  1303,  1307,  1310,
    1313,  1316,  1318,  1322,  1325,  1328,  1331,  1334,  1338,  1341,
    1344,  1347,  1351,  1354,  1357,  1360,  1364,  1367,  1372,  1375,
    1378,  1381,  1385,  1389,  1393,  1395,  1396,  1399,  1401,  1403,
    1406,  1410,  1411,  1414,  1416,  1418,  1421,  1425,  1426,  1427,
    1431,  1432,  1436,  1440,  1442,  1443,  1448,  1455,  1462,  1469,
    1476,  1479,  1483,  1487,  1493,  1498,  1503,  1506,  1510,  1514,
    1519,  1524,  1529,  1535,  1541,  1546,  1550,  1555,  1560,  1565,
    1570,  1572,  1574,  1576,  1578,  1580,  1582,  1584,  1586,  1587,
    1590,  1593,  1594,  1598,  1599,  1603,  1604,  1608,  1611,  1615,
    1619,  1623,  1626,  1630,  1634,  1637,  1640,  1643,  1648,  1650,
    1652,  1654,  1656,  1658,  1660,  1662,  1664,  1666,  1668,  1670,
    1672,  1674,  1676,  1678,  1680,  1682,  1684,  1686,  1688,  1690,
    1692,  1694,  1696,  1698,  1700,  1702,  1704,  1706,  1708,  1710,
    1712,  1714,  1716,  1718,  1720,  1722,  1724,  1726,  1728,  1730,
    1732,  1735,  1738,  1741,  1744,  1747,  1750,  1753,  1756,  1760,
    1764,  1768,  1772,  1776,  1780,  1784,  1786,  1788,  1790,  1792,
    1794,  1796,  1798,  1800,  1802,  1804,  1806,  1808,  1810
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     272,     0,    -1,   273,     3,    -1,     4,   449,    -1,    -1,
     273,   448,    -1,    13,    -1,   261,   389,   262,    -1,    17,
      -1,    31,    17,    20,   274,   263,    -1,    31,    17,    20,
      16,   263,    -1,   274,    -1,    32,    -1,    34,    -1,    33,
      -1,    35,    -1,    -1,    16,    -1,    17,    -1,   277,   280,
      -1,   278,    -1,   277,    -1,    28,   274,    -1,   264,   277,
      -1,    18,    -1,    18,    -1,    -1,    36,   284,   285,   263,
      -1,    18,    -1,    37,    -1,    48,    -1,    38,    -1,   265,
     286,   266,    -1,   287,    -1,   286,   267,   287,    -1,    39,
      -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,
      -1,    45,    -1,    46,    -1,    47,    -1,    50,   291,     3,
      -1,    50,    49,   291,     3,    -1,    51,     3,    -1,    -1,
      18,    -1,   303,    52,    -1,    53,   276,    -1,    54,    55,
     274,    -1,    56,   276,    -1,   303,    57,    -1,    54,    55,
     274,    -1,    82,   282,   279,    -1,    52,    59,   274,    -1,
      60,    61,   298,   263,    -1,    13,    -1,    15,    -1,    16,
      -1,    89,    90,   300,   263,    -1,    -1,   300,   301,    -1,
      92,   277,    -1,    93,   274,    -1,    91,    -1,    59,    17,
      -1,    62,    -1,    -1,    17,    -1,    -1,    63,   274,    -1,
      64,   276,    -1,    39,   318,    -1,    67,   306,    -1,    68,
     306,    -1,    59,   307,    -1,    60,    61,   298,    -1,    95,
      18,    -1,    69,   362,    -1,   363,    -1,    38,    -1,    70,
      -1,    17,    -1,    39,    80,   318,    -1,    39,    86,   274,
      -1,    -1,    18,    -1,   278,    -1,    18,   278,    -1,    -1,
      26,    -1,   309,   311,   310,    -1,   312,    -1,   313,   267,
     312,    -1,   303,    65,    -1,   314,   304,   265,    -1,   315,
     305,   263,    -1,   315,   317,   263,    -1,    -1,    66,   316,
     313,    -1,    38,    -1,    33,    -1,   265,   319,   266,    -1,
     320,    -1,   319,   267,   320,    -1,    71,    -1,    72,    -1,
      73,    -1,    81,    -1,    78,    -1,    79,    -1,    94,   265,
     322,   266,    -1,   323,    -1,    -1,   323,   263,   322,    -1,
     324,   265,   325,   266,    -1,   324,    -1,    74,    18,    -1,
      -1,    88,    75,   281,   263,   325,    -1,    88,    77,   281,
     263,   325,    -1,   118,    75,   281,   263,   325,    -1,   118,
      77,   281,   263,   325,    -1,    61,   274,   263,   325,    -1,
      99,   100,     3,    -1,    99,    80,   329,     3,    -1,    99,
      80,    38,   329,     3,    -1,    17,    -1,    -1,    99,    81,
       3,    -1,    99,    81,   101,     3,    -1,    99,   102,   333,
       3,    -1,    -1,   333,   278,    -1,   333,    85,   279,    -1,
     333,    59,    17,    -1,   333,    69,   362,    -1,   333,   363,
      -1,   333,    38,    -1,   333,    82,    -1,   333,   334,    17,
      -1,   333,    62,    17,    -1,   333,    83,    -1,   333,    84,
      -1,    87,    -1,    68,    -1,    99,   103,   329,     3,    -1,
     104,   105,     3,    -1,   104,   106,     3,    -1,   104,    81,
       3,    -1,   104,   107,     3,    -1,   104,   108,     3,    -1,
     104,    72,     3,    -1,   104,    80,     3,    -1,   109,   344,
     345,     3,    -1,    38,    -1,    33,    -1,    13,    -1,    -1,
      13,    -1,   110,   353,     3,    -1,   111,   353,     3,    -1,
     112,   353,     3,    -1,    96,   353,     3,    -1,    96,    97,
     353,     3,    -1,    96,    98,   353,     3,    -1,    39,   353,
     318,     3,    -1,    17,    -1,    38,    -1,    18,    -1,    -1,
      69,    17,   355,   361,    -1,   157,   389,    -1,   121,    -1,
     122,    -1,   123,    -1,   124,    -1,   125,    -1,   127,    -1,
     128,    -1,   129,    -1,   130,    -1,   357,   126,    -1,   357,
      17,    -1,    -1,   358,   263,   359,    -1,   358,    -1,   360,
     263,   358,    -1,   365,    -1,    17,    -1,   361,    -1,   156,
     389,    -1,   261,   360,   262,    -1,   261,   262,    -1,   359,
     265,   368,   266,    -1,    -1,   113,    17,   367,   364,   365,
      -1,    -1,   395,   368,    -1,   395,    -1,   265,   368,   266,
      -1,   261,    13,   267,    13,   262,    -1,    16,    -1,    13,
      -1,   370,    -1,   371,    -1,    14,    -1,   372,    -1,   372,
      24,    24,   372,    -1,   373,    -1,   374,   267,   373,    -1,
      16,    28,    13,    -1,   375,    -1,   375,    25,    -1,   375,
      26,    -1,   375,   265,    13,   267,    13,   266,    -1,   376,
      -1,   377,   267,   376,    -1,    -1,   373,   264,   368,   378,
      -1,   133,   264,   368,    -1,   387,    -1,   261,   389,   262,
      -1,    11,   381,    12,    -1,    28,   382,    28,    -1,    13,
     381,    -1,    27,   381,    -1,   268,   381,    -1,   379,   381,
      -1,    -1,    13,   382,    -1,   268,   382,    -1,    -1,   261,
     389,   267,   389,   262,    -1,    13,    -1,   135,    -1,   136,
      -1,    18,    -1,   371,    -1,   375,    -1,   269,   374,   270,
      -1,   269,   377,   270,    -1,    14,    -1,   380,    -1,    -1,
      17,   261,   394,   262,    -1,    17,    -1,    75,    -1,   137,
      -1,   138,    -1,   140,    -1,   141,    -1,   142,    -1,   143,
      -1,   144,    -1,   261,   389,   262,    -1,   389,    25,   389,
      -1,   389,    26,   389,    -1,   389,    27,   389,    -1,   389,
      28,   389,    -1,   389,     9,   389,    -1,   389,    10,   389,
      -1,   389,    20,   389,    -1,   389,     8,   389,    -1,   389,
      21,   389,    -1,   389,     7,   389,    -1,   389,    22,   389,
      -1,   389,     6,   389,    -1,   389,    23,   389,    -1,    30,
     389,    -1,   146,   261,   389,   262,    -1,   387,    -1,   384,
      -1,   383,    -1,    63,    -1,   385,   388,    -1,   385,   453,
      -1,   389,    24,   123,    -1,   389,    24,   145,    -1,   389,
      24,   139,   261,   389,   262,    -1,   389,    24,   152,    -1,
     389,    24,   153,    -1,    25,   155,    25,    -1,    26,   155,
      26,    -1,   151,   261,   389,   267,   389,   262,    -1,   147,
     261,   389,   267,   389,   262,    -1,   148,   261,   389,   267,
     389,   262,    -1,    17,   261,   394,   262,    -1,   120,    -1,
     118,    -1,   119,    -1,    44,    -1,   114,    -1,   115,    -1,
     389,    -1,    -1,   391,    -1,   391,   267,   392,    -1,   389,
      -1,   389,   267,   393,    -1,    -1,   393,    -1,   131,   389,
     132,   369,    -1,   131,   389,   132,   369,   133,   369,    -1,
      17,    20,   389,   263,    -1,   117,   389,   263,    -1,   385,
     453,    20,   389,   263,    -1,   385,   388,    20,   389,   263,
      -1,    63,    20,   389,   263,    -1,   116,   261,   385,   453,
     262,   263,    -1,   390,   392,   263,    -1,   386,   263,    -1,
     134,   389,   265,   378,   266,    -1,   385,   453,    24,   155,
     263,    -1,   385,   453,    24,   151,   261,   389,   262,   263,
      -1,   385,   453,    24,   147,   261,   389,   262,   263,    -1,
     385,   453,    24,   148,   261,   389,   262,   263,    -1,   303,
      90,    -1,   396,   304,   265,    -1,   397,   305,   263,    -1,
     397,   158,   160,   274,   263,    -1,   397,   159,   277,   160,
     274,   263,    -1,   397,   187,   190,    61,   274,   263,    -1,
     397,   187,   189,   263,    -1,   397,   188,   189,   263,    -1,
     397,   161,    55,   274,   263,    -1,   397,   166,   161,    55,
     274,   263,    -1,   397,   162,   163,    55,   274,   263,    -1,
     397,   164,    55,   274,   263,    -1,   397,   165,   274,   167,
     277,   263,    -1,   397,   168,   169,   170,   263,    -1,   397,
     198,   199,   170,   263,    -1,   397,   198,   199,   200,   263,
      -1,   397,   198,   199,   201,   263,    -1,   397,   172,   173,
     276,   263,    -1,   397,   196,   197,   276,   263,    -1,   397,
     171,   181,   274,   263,    -1,   397,   171,   180,   274,   263,
      -1,   397,   141,    92,   277,   263,    -1,   397,   174,   175,
      55,   274,   263,    -1,   397,    44,   176,    55,   274,   263,
      -1,   397,    44,   177,    55,   274,   267,   274,   263,    -1,
     397,   110,   178,    44,   276,   263,    -1,   397,   111,   102,
     202,   276,   263,    -1,   397,   111,   191,   276,   263,    -1,
     397,   194,   276,   263,    -1,   397,   192,   193,   276,   263,
      -1,   397,    74,    18,   263,    -1,   397,   102,   195,   274,
     263,    -1,   397,    76,   276,   263,    -1,   303,   203,    -1,
     398,   304,   265,    -1,   399,   400,   263,    -1,   305,    -1,
     209,   276,    -1,   211,   274,    -1,   402,   266,    -1,   204,
     298,   265,    -1,   401,   403,    -1,    -1,   403,   404,   263,
      -1,   210,   212,   274,    -1,   210,   276,    -1,   227,   265,
     414,   266,    -1,   235,   405,    -1,    66,   425,    -1,   409,
      -1,   406,   265,   407,   266,    -1,   406,    -1,   278,    -1,
      -1,   407,   408,   263,    -1,   228,   276,    -1,   101,   276,
      -1,   212,   274,    -1,   412,   265,   410,   266,    -1,   412,
      -1,    -1,   410,   411,   263,    -1,    -1,   214,   274,    -1,
     213,   274,    -1,   215,   175,   274,    -1,   177,   274,    -1,
     217,   274,    -1,   217,    84,   274,    -1,   222,    70,    -1,
     222,   221,    -1,   222,   224,    -1,   321,    -1,   229,   230,
     298,    -1,   212,   274,    -1,   214,   274,    -1,   226,   274,
      -1,   213,   274,    -1,   215,   175,   274,    -1,   216,   274,
      -1,   177,   274,    -1,   217,   274,    -1,   217,    84,   274,
      -1,   220,   208,    -1,   220,   218,    -1,   220,   219,    -1,
     223,   218,   276,    -1,   210,   276,    -1,   107,   265,   418,
     266,    -1,   222,    70,    -1,   222,   221,    -1,   222,   224,
      -1,   231,   232,   233,    -1,   231,   232,   234,    -1,   231,
     232,   274,    -1,   321,    -1,    -1,   414,   415,    -1,   416,
      -1,   417,    -1,   278,   263,    -1,   278,   228,   263,    -1,
      -1,   418,   419,    -1,   420,    -1,   421,    -1,    16,   263,
      -1,    16,   225,   263,    -1,    -1,    -1,   423,   413,   263,
      -1,    -1,   265,   423,   266,    -1,   422,   313,   424,    -1,
      18,    -1,    -1,    99,   203,   329,     3,    -1,    99,   203,
     107,   329,   426,     3,    -1,    99,   203,    66,   329,   426,
       3,    -1,    99,   203,   236,   329,   426,     3,    -1,    99,
     203,   237,   329,   426,     3,    -1,   303,   238,    -1,   432,
     304,   265,    -1,   433,   305,   263,    -1,   433,   239,    59,
      17,   263,    -1,   433,   240,   241,   263,    -1,   433,   240,
     242,   263,    -1,   303,   243,    -1,   434,   304,   265,    -1,
     435,   305,   263,    -1,   435,   244,   274,   263,    -1,   435,
      93,   274,   263,    -1,   435,   245,   274,   263,    -1,   435,
     246,    55,   274,   263,    -1,   435,   247,    55,   274,   263,
      -1,   435,   222,   436,   263,    -1,   435,   321,   263,    -1,
     435,   254,   256,   263,    -1,   435,   254,   159,   263,    -1,
     435,   254,   255,   263,    -1,   435,    66,   442,   263,    -1,
     252,    -1,   253,    -1,    70,    -1,   208,    -1,   248,    -1,
     249,    -1,   250,    -1,   251,    -1,    -1,   173,   274,    -1,
     240,   437,    -1,    -1,   439,   438,   263,    -1,    -1,   265,
     439,   266,    -1,    -1,   441,   313,   440,    -1,   303,   259,
      -1,   443,   304,   265,    -1,   444,   305,   263,    -1,   444,
     446,   263,    -1,   102,   278,    -1,   445,   167,   277,    -1,
     445,   167,    18,    -1,   445,   200,    -1,   445,   119,    -1,
     445,   260,    -1,    99,   259,   329,     3,    -1,   263,    -1,
     275,    -1,   283,    -1,   297,    -1,   299,    -1,   302,    -1,
     450,    -1,   308,    -1,   354,    -1,   356,    -1,   366,    -1,
     288,    -1,   289,    -1,   290,    -1,   326,    -1,   327,    -1,
     328,    -1,   330,    -1,   331,    -1,   332,    -1,   335,    -1,
     336,    -1,   337,    -1,   338,    -1,   339,    -1,   340,    -1,
     341,    -1,   342,    -1,   343,    -1,   346,    -1,   347,    -1,
     348,    -1,   349,    -1,   350,    -1,   351,    -1,   352,    -1,
     427,    -1,   428,    -1,   429,    -1,   430,    -1,   431,    -1,
     447,    -1,   451,   266,    -1,   452,   266,    -1,   315,   266,
      -1,   397,   266,    -1,   399,   266,    -1,   433,   266,    -1,
     435,   266,    -1,   444,   266,    -1,   292,   304,   265,    -1,
     451,   305,   263,    -1,   451,   293,   263,    -1,   451,   296,
     263,    -1,   294,   304,   265,    -1,   452,   305,   263,    -1,
     452,   295,   263,    -1,     5,    -1,   179,    -1,   180,    -1,
     181,    -1,   182,    -1,   183,    -1,   184,    -1,   185,    -1,
     186,    -1,   205,    -1,   206,    -1,   207,    -1,   257,    -1,
     258,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   294,   294,   295,   298,   300,   307,   308,   309,   313,
     317,   326,   327,   328,   329,   330,   331,   337,   338,   345,
     352,   353,   357,   361,   368,   376,   377,   383,   392,   397,
     398,   402,   403,   407,   408,   412,   413,   414,   415,   416,
     417,   418,   419,   420,   427,   430,   433,   437,   438,   446,
     462,   463,   467,   479,   492,   496,   509,   521,   527,   528,
     529,   540,   542,   544,   548,   549,   550,   557,   565,   569,
     575,   581,   583,   587,   588,   589,   590,   591,   592,   593,
     597,   598,   599,   600,   604,   612,   613,   619,   627,   628,
     629,   633,   634,   638,   643,   644,   651,   660,   661,   662,
     666,   675,   681,   682,   683,   687,   688,   692,   693,   694,
     695,   696,   697,   703,   704,   707,   709,   713,   714,   718,
     736,   737,   738,   739,   740,   741,   749,   752,   755,   759,
     760,   763,   766,   769,   773,   779,   785,   792,   797,   802,
     807,   811,   815,   825,   833,   837,   844,   845,   848,   852,
     854,   856,   858,   860,   862,   864,   867,   873,   874,   875,
     879,   880,   886,   888,   890,   892,   894,   896,   900,   905,
     906,   907,   913,   913,   922,   926,   927,   928,   929,   930,
     931,   932,   933,   934,   935,   954,   965,   966,   973,   974,
     981,   990,   994,   998,  1022,  1023,  1027,  1033,  1033,  1046,
    1047,  1058,  1061,  1070,  1077,  1081,  1082,  1083,  1084,  1088,
    1093,  1101,  1102,  1106,  1113,  1114,  1115,  1116,  1123,  1124,
    1127,  1128,  1133,  1144,  1145,  1149,  1150,  1154,  1155,  1156,
    1157,  1158,  1162,  1163,  1164,  1168,  1181,  1182,  1183,  1184,
    1185,  1186,  1187,  1188,  1189,  1190,  1200,  1204,  1227,  1260,
    1262,  1263,  1264,  1265,  1266,  1267,  1268,  1272,  1273,  1274,
    1275,  1276,  1277,  1278,  1279,  1280,  1281,  1282,  1283,  1284,
    1285,  1286,  1287,  1289,  1290,  1291,  1293,  1295,  1297,  1299,
    1300,  1301,  1302,  1303,  1313,  1314,  1315,  1316,  1317,  1322,
    1345,  1346,  1347,  1348,  1349,  1350,  1354,  1357,  1358,  1359,
    1368,  1375,  1384,  1385,  1389,  1395,  1405,  1414,  1420,  1425,
    1432,  1437,  1443,  1444,  1445,  1453,  1455,  1456,  1457,  1463,
    1482,  1483,  1484,  1485,  1491,  1492,  1493,  1494,  1495,  1496,
    1497,  1498,  1499,  1500,  1501,  1502,  1503,  1504,  1505,  1506,
    1507,  1508,  1509,  1510,  1511,  1512,  1513,  1514,  1515,  1516,
    1517,  1518,  1527,  1537,  1538,  1542,  1543,  1544,  1545,  1548,
    1560,  1563,  1565,  1569,  1570,  1571,  1572,  1573,  1574,  1578,
    1579,  1583,  1591,  1593,  1597,  1598,  1599,  1603,  1604,  1607,
    1609,  1612,  1613,  1614,  1615,  1616,  1617,  1618,  1619,  1620,
    1621,  1622,  1625,  1647,  1648,  1649,  1650,  1651,  1652,  1653,
    1654,  1655,  1656,  1657,  1658,  1659,  1660,  1661,  1662,  1663,
    1664,  1665,  1666,  1667,  1668,  1671,  1673,  1677,  1678,  1680,
    1689,  1699,  1701,  1705,  1706,  1708,  1717,  1728,  1750,  1752,
    1755,  1757,  1761,  1765,  1766,  1770,  1773,  1776,  1779,  1782,
    1788,  1796,  1797,  1798,  1803,  1804,  1810,  1817,  1818,  1819,
    1820,  1821,  1822,  1823,  1824,  1825,  1826,  1827,  1828,  1829,
    1833,  1834,  1835,  1840,  1841,  1842,  1843,  1844,  1847,  1848,
    1849,  1852,  1854,  1857,  1859,  1863,  1872,  1879,  1886,  1887,
    1888,  1891,  1900,  1904,  1910,  1911,  1912,  1915,  1922,  1922,
    1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1922,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,  1923,
    1924,  1924,  1924,  1924,  1924,  1924,  1924,  1924,  1925,  1925,
    1925,  1925,  1926,  1926,  1926,  1927,  1927,  1928,  1929,  1930,
    1931,  1932,  1933,  1934,  1935,  1935,  1935,  1935,  1935
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM", "ENUM", "RTRID",
  "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'", "'>'", "'~'", "'.'",
  "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "DEFINE", "ON", "OFF", "YES",
  "NO", "LOG", "SYSLOG", "ALL", "DEBUG", "TRACE", "INFO", "REMOTE",
  "WARNING", "ERROR", "AUTH", "FATAL", "BUG", "STDERR", "SOFT",
  "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN",
  "DEVICE", "ASYNC", "TABLE", "ROUTER", "ID", "PROTOCOL", "PREFERENCE",
  "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT", "FILTER", "NONE",
  "STATES", "ROUTES", "FILTERS", "PASSWORD", "FROM", "PASSIVE", "TO",
  "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES", "PRIMARY", "STATS",
  "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE", "LISTEN", "BGP",
  "V6ONLY", "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "RELOAD", "IN",
  "OUT", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS", "DUMP",
  "RESOURCES", "SOCKETS", "NEIGHBORS", "ATTRIBUTES", "ECHO", "DISABLE",
  "ENABLE", "RESTART", "FUNCTION", "PRINT", "PRINTN", "UNSET", "RETURN",
  "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP", "PREFIX", "PAIR",
  "SET", "STRING", "BGPMASK", "BGPPATH", "CLIST", "IF", "THEN", "ELSE",
  "CASE", "TRUE", "FALSE", "GW", "NET", "MASK", "PROTO", "SOURCE", "SCOPE",
  "CAST", "DEST", "LEN", "DEFINED", "ADD", "DELETE", "CONTAINS", "RESET",
  "PREPEND", "FIRST", "LAST", "MATCH", "EMPTY", "WHERE", "EVAL", "LOCAL",
  "NEIGHBOR", "AS", "HOLD", "CONNECT", "RETRY", "KEEPALIVE", "MULTIHOP",
  "STARTUP", "VIA", "NEXT", "HOP", "SELF", "DEFAULT", "PATH", "METRIC",
  "START", "DELAY", "FORGET", "WAIT", "AFTER", "BGP_PATH",
  "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY", "RR", "RS",
  "CLIENT", "CLUSTER", "AS4", "ADVERTISE", "IPV4", "CAPABILITIES", "LIMIT",
  "PREFER", "OLDER", "MISSING", "LLADDR", "DROP", "IGNORE", "REFRESH",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG", "BROADCAST",
  "RFC1583COMPAT", "STUB", "TICK", "COST", "RETRANSMIT", "HELLO",
  "TRANSMIT", "PRIORITY", "DEAD", "NONBROADCAST", "POINTOPOINT", "TYPE",
  "SIMPLE", "AUTHENTICATION", "STRICT", "CRYPTOGRAPHIC", "ELIGIBLE",
  "POLL", "NETWORKS", "HIDDEN", "VIRTUAL", "LINK", "RX", "BUFFER", "LARGE",
  "NORMAL", "STUBNET", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE",
  "OPAQUE", "TRANSPARENT", "RIP", "INFINITY", "PERIOD", "GARBAGE",
  "TIMEOUT", "MULTICAST", "QUIET", "NOLISTEN", "VERSION1", "PLAINTEXT",
  "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC", "RIP_TAG", "STATIC",
  "PROHIBIT", "'('", "')'", "';'", "':'", "'{'", "'}'", "','", "'?'",
  "'['", "']'", "$accept", "config", "conf_entries", "expr", "definition",
  "bool", "ipa", "prefix", "prefix_or_ipa", "pxlen", "datetime",
  "text_or_none", "log_config", "log_file", "log_mask", "log_mask_list",
  "log_cat", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_DOWN", "cfg_name",
  "kern_proto_start", "kern_item", "kif_proto_start", "kif_item",
  "nl_item", "rtrid", "idval", "listen", "listen_opts", "listen_opt",
  "newtab", "proto_start", "proto_name", "proto_item", "imexport",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_or_preexport", "cmd_SHOW_SYMBOLS",
  "cmd_DUMP_RESOURCES", "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "proto_patt",
  "filter_def", "$@1", "filter_eval", "type", "one_decl", "decls",
  "declsn", "filter_body", "filter", "where_filter", "function_params",
  "function_body", "function_def", "$@2", "cmds", "block", "cpair", "fipa",
  "set_atom", "set_item", "set_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "dpair", "constant", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bgp_proto_start", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_el", "pref_hid",
  "ipa_list", "ipa_item", "ipa_el", "ipa_ne", "ospf_iface_start",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_STATE", "pipe_proto_start",
  "pipe_proto", "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode",
  "rip_iface_item", "rip_iface_opts", "rip_iface_opt_list",
  "rip_iface_init", "rip_iface", "static_proto_start", "static_proto",
  "stat_route0", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
      61,    60,    62,   126,    46,    43,    45,    42,    47,    37,
      33,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,    40,    41,    59,    58,   123,   125,    44,    63,    91,
      93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   271,   272,   272,   273,   273,   274,   274,   274,   275,
     275,   276,   276,   276,   276,   276,   276,   277,   277,   278,
     279,   279,   280,   280,   281,   282,   282,   283,   284,   284,
     284,   285,   285,   286,   286,   287,   287,   287,   287,   287,
     287,   287,   287,   287,   288,   289,   290,   291,   291,   292,
     293,   293,   293,   294,   295,   295,   296,   297,   298,   298,
     298,   299,   300,   300,   301,   301,   301,   302,   303,   304,
     304,   305,   305,   305,   305,   305,   305,   305,   305,   305,
     306,   306,   306,   306,   307,   308,   308,   309,   310,   310,
     310,   311,   311,   312,   313,   313,   314,   315,   315,   315,
     316,   317,   318,   318,   318,   319,   319,   320,   320,   320,
     320,   320,   320,   321,   321,   322,   322,   323,   323,   324,
     325,   325,   325,   325,   325,   325,   326,   327,   328,   329,
     329,   330,   331,   332,   333,   333,   333,   333,   333,   333,
     333,   333,   333,   333,   333,   333,   334,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   344,   344,
     345,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     353,   353,   355,   354,   356,   357,   357,   357,   357,   357,
     357,   357,   357,   357,   357,   358,   359,   359,   360,   360,
     361,   362,   362,   363,   364,   364,   365,   367,   366,   368,
     368,   369,   369,   370,   371,   372,   372,   372,   372,   373,
     373,   374,   374,   375,   376,   376,   376,   376,   377,   377,
     378,   378,   378,   379,   379,   380,   380,   381,   381,   381,
     381,   381,   382,   382,   382,   383,   384,   384,   384,   384,
     384,   384,   384,   384,   384,   384,   385,   386,   387,   388,
     388,   388,   388,   388,   388,   388,   388,   389,   389,   389,
     389,   389,   389,   389,   389,   389,   389,   389,   389,   389,
     389,   389,   389,   389,   389,   389,   389,   389,   389,   389,
     389,   389,   389,   389,   389,   389,   389,   389,   389,   389,
     390,   390,   390,   390,   390,   390,   391,   392,   392,   392,
     393,   393,   394,   394,   395,   395,   395,   395,   395,   395,
     395,   395,   395,   395,   395,   395,   395,   395,   395,   396,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   398,   399,   399,   400,   400,   400,   400,   401,
     402,   403,   403,   404,   404,   404,   404,   404,   404,   405,
     405,   406,   407,   407,   408,   408,   408,   409,   409,   410,
     410,   411,   411,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   412,   413,   413,   413,   413,   413,   413,   413,
     413,   413,   413,   413,   413,   413,   413,   413,   413,   413,
     413,   413,   413,   413,   413,   414,   414,   415,   415,   416,
     417,   418,   418,   419,   419,   420,   421,   422,   423,   423,
     424,   424,   425,   426,   426,   427,   428,   429,   430,   431,
     432,   433,   433,   433,   433,   433,   434,   435,   435,   435,
     435,   435,   435,   435,   435,   435,   435,   435,   435,   435,
     436,   436,   436,   437,   437,   437,   437,   437,   438,   438,
     438,   439,   439,   440,   440,   441,   442,   443,   444,   444,
     444,   445,   446,   446,   446,   446,   446,   447,   448,   448,
     448,   448,   448,   448,   448,   448,   448,   448,   448,   449,
     449,   449,   449,   449,   449,   449,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   449,   449,   449,   449,   449,
     449,   449,   449,   449,   449,   449,   449,   449,   449,   449,
     450,   450,   450,   450,   450,   450,   450,   450,   451,   451,
     451,   451,   452,   452,   452,   453,   453,   453,   453,   453,
     453,   453,   453,   453,   453,   453,   453,   453,   453
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     1,     3,     1,     5,
       5,     1,     1,     1,     1,     1,     0,     1,     1,     2,
       1,     1,     2,     2,     1,     1,     0,     4,     1,     1,
       1,     1,     3,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     4,     2,     0,     1,     2,
       2,     3,     2,     2,     3,     3,     3,     4,     1,     1,
       1,     4,     0,     2,     2,     2,     1,     2,     1,     0,
       1,     0,     2,     2,     2,     2,     2,     2,     3,     2,
       2,     1,     1,     1,     1,     3,     3,     0,     1,     1,
       2,     0,     1,     3,     1,     3,     2,     3,     3,     3,
       0,     3,     1,     1,     3,     1,     3,     1,     1,     1,
       1,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     3,     4,     5,     1,
       0,     3,     4,     4,     0,     2,     3,     3,     3,     2,
       2,     2,     3,     3,     2,     2,     1,     1,     4,     3,
       3,     3,     3,     3,     3,     3,     4,     1,     1,     1,
       0,     1,     3,     3,     3,     3,     4,     4,     4,     1,
       1,     1,     0,     4,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     0,     3,     1,     3,
       1,     1,     1,     2,     3,     2,     4,     0,     5,     0,
       2,     1,     3,     5,     1,     1,     1,     1,     1,     1,
       4,     1,     3,     3,     1,     2,     2,     6,     1,     3,
       0,     4,     3,     1,     3,     3,     3,     2,     2,     2,
       2,     0,     2,     2,     0,     5,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     1,     0,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     4,     1,     1,     1,     1,     2,     2,     3,
       3,     6,     3,     3,     3,     3,     6,     6,     6,     4,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     3,
       1,     3,     0,     1,     4,     6,     4,     3,     5,     5,
       4,     6,     3,     2,     5,     5,     8,     8,     8,     2,
       3,     3,     5,     6,     6,     4,     4,     5,     6,     6,
       5,     6,     5,     5,     5,     5,     5,     5,     5,     5,
       5,     6,     6,     8,     6,     6,     5,     4,     5,     4,
       5,     4,     2,     3,     3,     1,     2,     2,     2,     3,
       2,     0,     3,     3,     2,     4,     2,     2,     1,     4,
       1,     1,     0,     3,     2,     2,     2,     4,     1,     0,
       3,     0,     2,     2,     3,     2,     2,     3,     2,     2,
       2,     1,     3,     2,     2,     2,     2,     3,     2,     2,
       2,     3,     2,     2,     2,     3,     2,     4,     2,     2,
       2,     3,     3,     3,     1,     0,     2,     1,     1,     2,
       3,     0,     2,     1,     1,     2,     3,     0,     0,     3,
       0,     3,     3,     1,     0,     4,     6,     6,     6,     6,
       2,     3,     3,     5,     4,     4,     2,     3,     3,     4,
       4,     4,     5,     5,     4,     3,     4,     4,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       2,     0,     3,     0,     3,     0,     3,     2,     3,     3,
       3,     2,     3,     3,     2,     2,     2,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     3,
       3,     3,     3,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    47,     0,     0,     0,     0,
       0,     0,     0,     0,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,     3,     1,     2,     0,     0,
       0,     0,     0,    68,     0,     0,     0,   246,   488,   489,
     490,    69,    69,   491,   492,   493,     0,   495,    69,    71,
     496,   497,   498,    69,    71,    69,    71,    69,    71,    69,
      71,    69,    71,     5,   494,    71,    71,   169,   171,   170,
       0,    48,    47,     0,    46,     0,     0,     0,   130,     0,
       0,   134,   130,   130,   130,     0,     0,     0,     0,     0,
       0,     0,   159,   158,   157,   160,     0,     0,     0,     0,
      28,    29,    30,     0,     0,     0,    67,     0,   172,    62,
     197,   231,   236,   244,   204,   248,   239,     0,     0,   234,
     246,   276,   237,   238,     0,     0,     0,     0,   246,     0,
     240,   241,   245,   275,   274,     0,   273,   174,    70,     0,
       0,    49,    53,    96,   319,   352,   440,   446,   477,     0,
       0,     0,     0,     0,    16,   100,     0,     0,     0,   532,
       0,     0,     0,     0,     0,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,     0,     0,   533,     0,     0,
       0,    16,     0,   534,   355,     0,   361,     0,     0,     0,
       0,   535,     0,     0,   475,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   536,     0,     0,   114,   118,     0,
       0,   537,     0,     0,     0,     0,    16,     0,    16,   530,
       0,     0,     0,     0,    26,   531,     0,     0,   103,   102,
       0,     0,     0,    44,     0,     0,   165,   129,   130,     0,
     131,     0,   126,     0,     0,   130,   130,   130,   130,     0,
       0,   154,   155,   151,   149,   150,   152,   153,   161,     0,
     162,   163,   164,     0,    31,     0,     0,    85,     6,     8,
     246,    86,    58,    59,    60,     0,   186,     0,     0,   231,
     248,   231,   246,   231,   231,     0,   223,     0,   246,     0,
       0,   234,   234,     0,   271,   246,   246,   246,   246,     0,
     205,   208,     0,   206,   207,   209,   211,     0,   214,   218,
       0,   545,   249,   250,   251,   252,   253,   254,   255,   256,
     546,   547,   548,   549,   550,   551,   552,   553,   554,   555,
     556,   557,   558,   277,   278,   246,   246,   246,   246,   246,
     246,   246,   246,   246,     0,   246,   246,   246,   246,   538,
     542,    97,    74,    84,    77,     0,    72,    12,    14,    13,
      15,    11,    73,    87,    82,   186,    83,   246,    75,    81,
      76,    79,    98,    99,   320,     0,     0,     0,     0,     0,
       0,     0,    16,     0,     0,    17,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    16,     0,     0,     0,
       0,    16,     0,    16,     0,   321,   353,     0,   356,   357,
     354,   360,   358,   441,     0,     0,     0,   442,   447,    87,
       0,   119,     0,   115,   462,   460,   461,     0,     0,     0,
       0,     0,     0,     0,     0,   448,   455,   120,   478,     0,
     481,   479,   485,     0,   484,   486,   480,     0,    50,     0,
      52,   540,   541,   539,     0,    25,     0,   544,   543,   107,
     108,   109,   111,   112,   110,     0,   105,   168,    45,   166,
     167,     0,   127,   132,   133,   140,     0,     0,   147,   186,
     141,   144,   145,     0,   146,   135,     0,   139,   148,   434,
     434,   434,   434,   435,   487,   156,     0,     0,    35,    36,
      37,    38,    39,    40,    41,    42,    43,     0,    33,    27,
       0,    57,   175,   176,   177,   178,   179,   180,   181,   182,
     183,     0,     0,     0,   173,   190,    66,     0,     0,    61,
      63,     0,   186,   227,   228,     0,   229,   230,   225,   213,
     300,   303,     0,   284,   285,   232,   233,   226,     0,     0,
       0,     0,   257,   246,     0,     0,     0,   242,   215,   216,
       0,     0,   243,   269,   267,   265,   262,   263,   264,   266,
     268,   270,   279,     0,   280,   282,   283,   258,   259,   260,
     261,    78,    91,    94,   101,   191,   192,    80,   193,     0,
       0,   349,   351,     0,    16,    16,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     325,     0,   326,     0,   347,     0,     0,     0,     0,   359,
     427,    16,     0,     0,     0,     0,   368,   378,     0,   444,
     445,   473,   459,   450,     0,     0,   454,   449,   451,     0,
       0,   457,   458,   456,     0,     0,     0,     0,     0,     0,
      19,   483,   482,    56,    51,    54,    21,    20,    55,   104,
       0,   128,   137,   143,   138,   136,   142,   433,     0,     0,
       0,     0,    10,     9,    32,     0,     7,   185,   184,   186,
     246,    64,    65,   195,   188,     0,   198,   224,   246,   289,
     272,   246,   246,   246,     0,     0,     0,   204,   212,     0,
       0,   219,   246,    92,     0,    87,     0,     0,   350,     0,
       0,   346,   340,   322,     0,   327,     0,   330,     0,     0,
     332,   339,   338,   336,     0,     0,   348,   337,   333,   334,
     335,    87,   367,     0,   364,   415,     0,   371,   366,   370,
     362,   379,   443,   471,   476,   113,   115,   452,   453,     0,
       0,     0,     0,     0,   117,    22,    23,   106,   437,   436,
     438,   439,    34,   187,     0,   293,     0,   294,   295,     0,
     246,   291,   292,   290,   246,   246,     0,     0,     0,   246,
     246,   194,     0,   301,     0,     0,     0,   235,     0,   210,
       0,     0,    88,    89,    93,    95,   342,     0,   344,   345,
     323,   329,   331,   328,   341,   324,   430,   363,     0,   392,
     372,   381,   468,   116,   120,    24,     0,     0,     0,     0,
     246,   246,   246,   246,     0,     0,     0,   196,     0,     0,
     313,   296,   298,     0,   200,   189,   287,   288,   286,   203,
       0,   281,    90,     0,   428,   432,   365,     0,   416,   417,
     418,     0,     0,     0,     0,     0,     0,     0,   377,   391,
       0,     0,     0,   474,     0,   125,   120,   120,   120,   120,
       0,     0,     0,     0,   307,   246,   220,   246,   246,     0,
     246,   312,   217,   343,     0,     0,   419,    16,     0,    16,
     369,     0,   385,   383,   382,     0,     0,   386,   388,   389,
     390,   380,   469,   463,   464,   465,   466,   467,   470,   472,
     121,   122,   123,   124,   306,   247,   310,     0,   246,   304,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     299,     0,     0,    16,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   431,   414,     0,   420,   375,
     376,   374,   373,   384,   387,     0,     0,   246,   246,   246,
     314,   309,   308,   246,   246,   246,   315,   421,   399,   406,
     393,   396,   394,     0,   398,     0,   400,   402,   403,   404,
     408,   409,   410,    16,   395,     0,   429,   311,   202,   305,
     222,   220,     0,     0,     0,     0,   397,   401,   405,   411,
     412,   413,   221,     0,     0,     0,     0,   407,   422,   423,
     424,   317,   318,   316,     0,   425,   426
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,   391,    59,   392,   469,   687,   688,   680,
     846,   486,    60,   123,   296,   537,   538,    14,    15,    16,
      93,    61,   250,    62,   256,   251,    63,   305,    64,   307,
     560,    65,    66,   159,   180,   398,   384,    67,   612,   824,
     734,   613,   614,    68,    69,   393,   181,   261,   495,   496,
     236,   664,   237,   238,   677,    17,    18,    19,   269,    20,
      21,    22,   273,   516,    23,    24,    25,    26,    27,    28,
      29,    30,    31,   115,   289,    32,    33,    34,    35,    36,
      37,    38,    90,    70,   306,    71,   551,   552,   553,   715,
     616,   617,   399,   562,   555,    72,   308,   806,   949,   333,
     150,   335,   952,   337,   151,   339,   340,   953,   314,   152,
     315,   323,   153,   154,   155,   808,   156,   363,   570,   809,
     862,   863,   571,   572,   810,    73,    74,    75,    76,   215,
     216,   217,   441,   655,   768,   769,   881,   921,   656,   841,
     890,   657,   977,   838,   878,   879,   880,  1025,  1038,  1039,
    1040,   761,   914,   875,   762,   698,    39,    40,    41,    42,
      43,    77,    78,    79,    80,   457,   938,   894,   842,   774,
     449,   450,    81,    82,   243,   244,    44,    83,    45,    84,
      85,    86,   364
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -841
static const yytype_int16 yypact[] =
{
      28,  1428,    36,   147,   445,   133,   114,   539,   486,   658,
     201,   445,   445,   445,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,    70,   399,
     -49,   156,    15,  -841,   176,    75,   208,   535,  -841,  -841,
    -841,   214,   214,  -841,  -841,  -841,   278,  -841,   214,  1299,
    -841,  -841,  -841,   214,  1183,   214,  1061,   214,  1067,   214,
    1236,   214,  1181,  -841,  -841,   159,   325,  -841,  -841,  -841,
     -20,  -841,   240,   295,  -841,   445,   445,   319,   138,    17,
     323,  -841,   316,   346,   316,   338,   343,   347,   355,   374,
     379,   383,  -841,  -841,  -841,   378,   397,   412,   435,   438,
    -841,  -841,  -841,   -17,   -20,    91,  -841,   498,  -841,  -841,
    -841,     6,  -841,  -841,   436,   215,  -841,   339,   342,     4,
     535,  -841,  -841,  -841,   219,   251,   261,   264,   535,    12,
    -841,  -841,  -841,  -841,  -841,  1011,  -841,  1535,  -841,   273,
     282,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,   290,
     -20,   528,   501,    91,   167,  -841,   300,   300,   541,  -841,
     301,   305,   329,   -23,   572,   167,   404,   434,   -75,   548,
     481,   172,   589,   482,   597,    91,   492,   487,    61,   485,
     480,   183,   470,   468,   167,   465,   473,  -841,   400,   408,
     498,   167,    91,  -841,  -841,   406,  -841,   418,   409,   626,
     204,  -841,   424,   423,  -841,   681,    91,   437,   -24,    91,
      91,   645,   646,   -85,  -841,   446,   447,  -841,   449,   450,
     172,  -841,   453,   -52,   454,   652,   167,   657,   167,  -841,
     466,   469,   471,   673,   695,  -841,   477,   478,  -841,  -841,
    1102,   728,   730,  -841,   733,   739,  -841,  -841,   316,   741,
    -841,   743,  -841,  1425,   746,   316,   316,   316,   316,   747,
     748,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,   750,
    -841,  -841,  -841,    56,  -841,   771,   491,  -841,  -841,  -841,
     535,  -841,  -841,  -841,  -841,   493,  1392,    99,   494,     6,
    -841,     6,   535,     6,     6,   745,  -841,   760,   331,   749,
     751,     4,     4,   752,  -841,   535,   535,   535,   535,    35,
    -841,  -841,   763,  -841,  -841,   754,  -841,   -50,    59,  -841,
     198,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,   535,   535,   535,   535,   535,
     535,   535,   535,   535,   515,   535,   535,   535,   535,  -841,
    -841,  -841,  -841,  -841,  -841,   498,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  1347,  -841,   535,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,   720,   724,   529,   534,    91,
     755,   596,   167,   172,    91,  -841,  -841,   631,    91,   773,
      91,   633,   774,   660,    91,    91,   167,   777,   540,   772,
     571,   167,   573,   167,   226,  -841,  -841,   570,  -841,  -841,
    -841,    11,  -841,  -841,   820,   576,   580,  -841,  -841,  -841,
     583,  -841,   584,   781,  -841,  -841,  -841,   585,   594,   599,
      91,    91,   612,   614,   615,  -841,  -841,   293,  -841,   -14,
    -841,  -841,  -841,   524,  -841,  -841,  -841,    91,  -841,    91,
    -841,  -841,  -841,  -841,    91,  -841,   172,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,   142,  -841,  -841,  -841,  -841,
    -841,   856,  -841,  -841,  -841,  -841,   863,   870,  -841,  1347,
    -841,  -841,  -841,   172,  -841,  -841,   871,  -841,  -841,   872,
     872,   872,   872,  -841,  -841,  -841,   629,   630,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,   252,  -841,  -841,
     762,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,    84,   632,   624,  -841,  -841,  -841,   172,    91,  -841,
    -841,   744,  1392,  -841,  -841,   799,  -841,  -841,  -841,  -841,
      72,  -841,   648,  -841,  -841,  -841,  -841,  -841,   876,   104,
     113,   136,  -841,   535,   627,   887,    38,  -841,  -841,  -841,
     900,   896,  -841,  1562,  1562,  1562,  1562,  1562,  1562,  1562,
    1562,  1562,  -841,   653,  -841,  -841,  -841,   422,   422,  -841,
    -841,  -841,   889,  -841,   649,  -841,  -841,  -841,  1535,    91,
      91,  -841,  -841,   654,   167,   167,   655,   671,   672,    91,
     676,    91,   677,   172,    91,   678,   693,   694,   696,    91,
    -841,    91,  -841,   697,  -841,   699,   700,   701,   716,  -841,
    -841,   162,   715,   779,   172,   718,  -841,   717,   756,  -841,
    -841,   -62,  -841,  -841,   692,   757,  -841,  -841,  -841,   758,
     759,  -841,  -841,  -841,    91,   160,   216,   742,    91,   172,
    -841,  -841,  -841,  -841,  -841,  -841,   -14,  -841,  -841,  -841,
    1102,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  1004,  1007,
    1014,  1015,  -841,  -841,  -841,   771,  -841,  -841,  -841,  1392,
    1051,  -841,  -841,  -841,  -841,   322,  -841,  -841,   535,  -841,
    -841,   535,   535,   535,   899,  1010,    38,  -841,  -841,   780,
     436,  -841,   535,  -841,   562,  -841,   782,   790,  -841,   783,
     795,  -841,  -841,  -841,   796,  -841,   797,  -841,   804,   806,
    -841,  -841,  -841,  -841,   808,   809,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,    91,  -841,  -841,   498,  -841,  -841,   776,
    -841,  -841,  -841,  -841,  -841,  -841,   781,  -841,  -841,   810,
    1057,  1057,  1057,  1057,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,    -8,  -841,  1024,  -841,  -841,   813,
     535,  -841,  -841,  -841,   535,   535,   819,  1011,   824,   388,
    1026,  -841,  1392,  -841,   922,   945,   968,  -841,   826,  -841,
    1077,   977,   172,  -841,  -841,  -841,  -841,    91,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,   157,  -841,    18,  -841,
    -841,  1231,    -7,  -841,   293,  -841,   828,   830,   831,   833,
     535,   331,   535,  -841,   464,  1379,   255,  -841,  1079,   148,
    -841,  1535,   834,   839,  -841,  -841,  -841,  -841,  -841,  -841,
     838,  -841,  -841,   845,  -841,  -841,  -841,  -188,  -841,  -841,
    -841,   155,    91,    91,    91,   935,    90,   154,  -841,  -841,
     850,    91,   182,  -841,   852,  -841,   293,   293,   293,   293,
     598,   835,   607,   390,  -841,  1095,    34,   535,   535,   495,
     388,  -841,  -841,  -841,  1207,   853,  -841,   167,    91,   167,
    -841,   854,  -841,  -841,  -841,    91,    91,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,   857,  1051,   985,
    -841,   858,   859,   866,   670,   698,   875,   886,   902,   874,
    -841,   868,    91,   167,    91,    91,    91,   975,    91,   168,
     179,   233,   946,    91,   940,  -841,  -841,   913,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,   914,   912,  1095,  1051,  1026,
    -841,  -841,  -841,   535,   535,   535,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,    91,  -841,    91,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,   167,  -841,    73,  -841,  -841,  -841,  -841,
    -841,    34,  1005,  1028,  1056,    23,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,   916,   923,   924,  -195,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,   925,  -841,  -841
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -841,  -841,  -841,  -124,  -841,  -182,  -181,  -235,   685,  -841,
    -250,  -841,  -841,  -841,  -841,  -841,   484,  -841,  -841,  -841,
    1107,  -841,  -841,  -841,  -841,  -841,  -841,  -208,  -841,  -841,
    -841,  -841,  -841,  1030,   778,  1023,  -841,  -841,  -841,  -841,
    -841,   467,  -438,  -841,  -841,  -841,  -841,  -100,  -841,   511,
    -825,   427,  -445,  -841,  -369,  -841,  -841,  -841,   225,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,   448,  -841,  -841,  -841,  -841,  -546,   496,  -841,
     898,   710,   933,  -841,   659,  -841,  -841,  -623,   221,  -841,
    -145,   497,  -142,  -841,  -143,   634,  -841,   203,  -841,  -841,
     195,   280,  -841,  -841,  -701,  -841,   126,   421,   -57,  -841,
    -841,   321,   514,   382,  -840,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,    89,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,  -841,
    -841,  -841,  -754
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -303
static const yytype_int16 yytable[] =
{
     157,   301,   437,   408,   334,   470,   338,   336,   665,   807,
     417,   661,   850,   258,   678,   714,   889,   321,   259,   309,
     270,   294,   432,   310,   297,   330,   331,   411,   134,   438,
    1044,   124,     1,   311,   415,   416,    46,   125,   515,  1036,
     915,   365,   366,   367,   368,   369,   454,   330,   331,   386,
     727,   330,   331,   859,   727,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   478,   950,   480,   472,  1045,   298,
     382,   421,   526,   299,   462,   916,   127,   650,   365,   366,
     367,   368,   369,   324,   588,   589,   298,   119,   439,   976,
     299,   329,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   707,   452,   298,   298,   458,   459,   299,   299,   807,
     365,   366,   367,   368,   369,   473,   412,    94,   271,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   365,   366,   367,   368,   369,   950,   474,   947,
      47,    91,   903,   405,   406,   267,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   129,   891,   951,   908,   527,
     463,   464,   909,   126,   926,   298,   268,   611,    48,   299,
     298,   298,    92,    49,   299,   299,    50,   864,   415,   416,
     556,   557,   558,   128,   387,   388,   389,   390,   170,   387,
     388,   389,   390,   773,   807,   735,    51,    52,   475,    53,
     708,   245,   246,   247,   112,   248,    54,   586,   171,   172,
     587,   651,   173,   174,   928,   130,   176,   177,   455,   456,
     626,   158,   627,   892,   113,   780,    55,   781,   652,   114,
     653,   424,   425,   540,   638,   260,   654,   807,   295,   643,
     679,   645,  1005,   851,   178,   565,   917,   316,    91,   893,
      56,   365,   366,   367,   368,   369,   865,   312,   578,   579,
     580,   581,   322,   332,   313,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   876,   623,   807,   807,   807,  1037,
     628,   782,   682,   783,   630,   332,   632,   582,   263,   332,
     636,   637,   583,  1010,    57,   686,  1029,  1030,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   300,   607,   608,
     609,   610,   266,   836,   590,   986,   272,   274,   279,   280,
     161,   665,   686,   267,   300,   162,   669,   670,   394,   718,
     618,   281,   131,   163,   132,   133,   282,   134,   135,   136,
     283,   300,   300,   683,   674,   684,   137,   138,   284,   139,
     685,   140,   559,   267,   170,  1020,  1021,   918,   164,   395,
     396,   721,   428,   429,   763,   929,   711,   285,   930,   253,
     722,   675,   286,   919,   171,   172,   287,  1007,   173,   174,
     933,   288,   176,   177,   141,   341,   646,  1008,  1009,   131,
     290,   132,   133,   723,   134,   135,   136,   254,   689,   690,
      58,   676,   275,   137,   138,   291,   139,   120,   140,   767,
     178,   920,   874,   300,   735,   249,   647,   648,   300,   300,
     934,   935,   936,   937,   712,   316,   121,   316,   292,   316,
     316,   334,   739,   740,   728,   445,   446,   122,   338,   377,
     378,   141,   748,   276,  1011,    97,   397,  1012,   293,   116,
     117,   118,    87,    88,   317,   591,   142,   143,   592,   764,
     365,   366,   367,   368,   369,   895,   318,   144,   145,   146,
     325,   165,   147,    89,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   501,   319,   736,   737,   320,   786,   823,
     519,   520,   521,   522,   563,   744,   564,   746,   566,   567,
     749,   302,   326,   303,   304,   754,   166,   755,   704,   705,
     906,   167,   327,   142,   143,   328,   724,   940,   941,   942,
     943,   847,   848,   849,   144,   145,   146,   168,   379,   147,
     415,   416,   681,   264,   265,   383,   131,   380,   132,   133,
     779,   134,   135,   136,   785,   381,    87,    88,   839,   401,
     137,   138,   385,   139,   402,   140,    98,    99,   403,   350,
     351,   352,   353,   354,   355,   356,   357,    89,   415,   416,
     822,   334,   277,   278,   811,   812,   100,   872,   101,   102,
     407,   255,   148,  -302,   404,   358,   359,   360,   141,   409,
     149,   575,   576,   877,   365,   366,   367,   368,   369,   699,
     700,   701,   410,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   370,   371,   372,
     373,   374,   375,   376,   377,   378,    95,    96,   602,   837,
     413,   414,   956,   957,   418,   419,   958,   361,   362,   148,
     959,  -297,   420,   422,   603,   427,   423,   149,   426,   430,
     604,   431,   433,   435,   814,   815,   816,   605,   606,   440,
     142,   143,   434,   436,   443,   821,   365,   366,   367,   368,
     369,   144,   145,   146,   442,   444,   147,   447,   448,   103,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   451,
     460,   461,   453,   873,   365,   366,   367,   368,   369,   465,
     466,   477,   479,   485,   467,   468,   471,   476,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   904,   484,   481,
     105,   497,   482,   498,   483,   979,   499,   981,   106,   107,
     487,   488,   500,   854,   502,   104,   503,   855,   856,   518,
     523,   524,   861,   525,   539,   561,   541,   568,   922,   923,
     924,   334,   927,   108,   109,   110,   111,   932,   365,   366,
     367,   368,   369,   569,   573,   619,   584,   574,   585,   620,
     577,   999,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   629,   621,   900,   980,   902,   148,   622,   625,   624,
     633,   983,   984,   640,   149,   365,   366,   367,   368,   369,
     528,   529,   530,   531,   532,   533,   534,   535,   536,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   631,   634,
     635,  1028,   639,   641,   642,   649,   644,   658,   998,   659,
    1000,  1001,  1002,   660,  1004,  1006,   662,   663,   666,  1014,
     954,   955,   208,   861,   214,   225,   222,   667,   235,   691,
     242,   944,   668,   252,   257,   542,   543,   544,   545,   546,
     946,   547,   548,   549,   550,   671,   334,   672,   673,  1026,
     692,  1027,   365,   366,   367,   368,   369,   693,   696,   710,
     697,  1031,   702,   703,   725,   709,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   365,   366,   367,   368,   369,
     719,   726,   730,   729,   732,   733,   735,   738,   741,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   365,   366,
     367,   368,   369,   991,   742,   743,  1022,  1023,  1024,   745,
     747,   750,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   365,   366,   367,   368,   369,   751,   752,   775,   753,
     756,   992,   757,   758,   759,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   365,   366,   367,   368,   369,   760,
     765,   770,   771,   365,   366,   367,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   713,   788,   784,   766,
     789,   365,   366,   367,   368,   369,   341,   790,   791,   772,
     776,   777,   778,   818,   706,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   365,   366,   367,   368,   369,  -199,
    -199,   840,  -199,   794,   852,   826,   828,   820,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   827,   829,   830,
     831,   717,   365,   366,   367,   368,   369,   832,   794,   833,
     795,   834,   835,   844,   853,   845,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   857,   342,   860,   869,   796,
     870,   896,   160,   897,   898,   795,   899,   945,   169,   907,
     170,   910,   911,   182,   912,   209,   170,   218,   913,   223,
     925,   239,   794,   931,   796,   939,   978,   982,   987,   985,
     171,   172,   988,   989,   173,   174,   171,   172,   176,   177,
     173,   174,   990,   997,   176,   177,   993,   996,   720,   795,
     797,   798,   799,   800,   801,   802,   803,   994,   343,   344,
    1003,   345,   346,   347,   348,   349,   178,   804,   796,  -199,
     805,   817,   178,   995,  1013,   797,   798,   799,   800,   801,
     802,   803,  1015,   489,   490,   491,  1016,  1017,  1018,  1041,
     492,   493,   804,   494,   866,   805,  1042,  1043,  1046,   792,
     350,   351,   352,   353,   354,   355,   356,   357,   695,   262,
     400,   787,   825,   843,   554,   793,   517,   867,  1019,   797,
     798,   799,   800,   801,   802,   803,   358,   359,   360,   694,
     170,   716,   170,   819,  1032,   731,   804,   183,   858,   805,
     868,   960,   813,   901,     0,     0,     0,     0,     0,   871,
     171,   172,   171,   172,   173,   174,   173,   174,   176,   177,
     176,   177,     0,     0,     0,     0,     0,   184,     0,   185,
       0,     0,     0,     0,     0,   210,     0,  1033,   361,   362,
     211,     0,   212,     0,     0,   170,   178,     0,   178,     0,
       0,   225,     0,   240,     0,   186,     0,  -199,     0,     0,
    1034,     0,  -199,   187,   188,   171,   172,     0,     0,   173,
     174,   227,   224,   176,   177,   225,   219,   220,     0,     0,
     225,     0,     0,     0,   961,     0,     0,  -199,  1035,     0,
       0,     0,     0,     0,   189,   227,     0,   213,     0,   226,
     227,   178,     0,   221,     0,     0,     0,     0,   170,     0,
       0,   190,   191,     0,   192,   193,     0,   194,   195,   196,
       0,   197,     0,     0,   198,   199,     0,   200,   171,   172,
     948,     0,   173,   174,   615,   175,   176,   177,     0,     0,
     201,   202,     0,     0,     0,   203,     0,   204,     0,   205,
       0,   206,     0,     0,   962,   365,   366,   367,   368,   369,
       0,     0,     0,     0,   178,     0,     0,     0,     0,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   882,     0,
       0,     0,     0,     0,     0,     0,     0,   963,     0,   964,
     965,   966,   967,   968,   969,     0,     0,   970,   504,   971,
     972,     0,     0,   973,     0,     0,     0,     0,   974,     0,
       0,   415,   416,     0,   883,   884,   885,   241,   886,   207,
       0,     0,     0,   887,     0,     0,     0,     0,   228,     0,
       0,     0,     0,   505,     0,     0,     0,     4,   542,   543,
     544,   545,   546,   975,   547,   548,   549,   550,     5,     6,
     229,   230,   231,   232,   506,     0,     0,   507,     0,     0,
     233,     0,     0,   508,   509,     0,     0,   888,     0,     0,
       0,     0,   234,     0,     0,     0,     0,   510,   511,   512,
     513,   905,   514,   542,   543,   544,   545,   546,     0,   547,
     548,   549,   550,     0,     7,     0,     0,     8,     0,     0,
       0,     0,     9,     0,     0,     0,     0,    10,    11,    12,
      13,   365,   366,   367,   368,   369,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   370,   371,   372,   373,   374,
     375,   376,   377,   378,     0,   179,     0,     0,  -303,  -303,
    -303,  -303,  -303,     0,     0,     0,     0,     0,     0,     0,
       0,   397,  -303,  -303,  -303,  -303,  -303,   375,   376,   377,
     378
};

static const yytype_int16 yycheck[] =
{
      57,   125,   210,   185,   149,   240,   149,   149,   453,   710,
     191,   449,    20,    33,    28,   561,   841,    13,    38,    13,
       3,    38,   204,    17,   124,    13,    14,   102,    16,   211,
     225,    80,     4,    27,    16,    17,     0,    86,   273,    16,
     228,     6,     7,     8,     9,    10,    70,    13,    14,   173,
      16,    13,    14,   807,    16,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   246,   905,   248,   119,   263,    13,
     170,   195,    16,    17,   159,   263,    61,    66,     6,     7,
       8,     9,    10,   140,    25,    26,    13,    17,   212,   914,
      17,   148,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    17,   226,    13,    13,   229,   230,    17,    17,   810,
       6,     7,     8,     9,    10,   167,   191,     3,   101,     6,
       7,     8,     9,    10,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    20,    21,    22,    23,    24,    25,    26,
      27,    28,     6,     7,     8,     9,    10,   987,   200,   903,
       3,    18,   853,   176,   177,    17,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    90,   173,   133,    20,   293,
     255,   256,    24,    17,    84,    13,    38,   385,    31,    17,
      13,    13,    49,    36,    17,    17,    39,   810,    16,    17,
      91,    92,    93,    17,    32,    33,    34,    35,    39,    32,
      33,    34,    35,   265,   905,   267,    59,    60,   260,    62,
     126,    52,    53,    54,    13,    56,    69,   267,    59,    60,
     270,   210,    63,    64,    70,    17,    67,    68,   252,   253,
     412,    17,   413,   240,    33,    75,    89,    77,   227,    38,
     229,   180,   181,   300,   426,   265,   235,   948,   265,   431,
     264,   433,    84,   261,    95,   312,   101,   131,    18,   266,
     113,     6,     7,     8,     9,    10,   812,   261,   325,   326,
     327,   328,   268,   261,   268,    20,    21,    22,    23,    24,
      25,    26,    27,    28,   266,   409,   987,   988,   989,   266,
     414,    75,   473,    77,   418,   261,   420,   262,     3,   261,
     424,   425,   267,    70,   157,   486,   233,   234,   365,   366,
     367,   368,   369,   370,   371,   372,   373,   261,   375,   376,
     377,   378,     3,   761,   265,   948,     3,   102,   103,   104,
      52,   776,   513,    17,   261,    57,   460,   461,    38,   267,
     397,     3,    11,    65,    13,    14,     3,    16,    17,    18,
       3,   261,   261,   477,    61,   479,    25,    26,     3,    28,
     484,    30,   263,    17,    39,   988,   989,   212,    90,    69,
      70,   267,   189,   190,   212,   221,   557,     3,   224,    54,
     267,    88,     3,   228,    59,    60,     3,   208,    63,    64,
     208,    13,    67,    68,    63,     5,   170,   218,   219,    11,
       3,    13,    14,   267,    16,    17,    18,    82,   266,   267,
     263,   118,    66,    25,    26,     3,    28,    18,    30,   654,
      95,   266,   265,   261,   267,   266,   200,   201,   261,   261,
     248,   249,   250,   251,   558,   309,    37,   311,     3,   313,
     314,   586,   624,   625,   586,   241,   242,    48,   591,    27,
      28,    63,   633,   107,   221,     7,   156,   224,    20,    11,
      12,    13,    17,    18,    28,   267,   135,   136,   270,   651,
       6,     7,     8,     9,    10,   844,   261,   146,   147,   148,
     261,   203,   151,    38,    20,    21,    22,    23,    24,    25,
      26,    27,    28,   268,   155,   619,   620,   155,   679,   734,
     275,   276,   277,   278,   309,   629,   311,   631,   313,   314,
     634,    13,   261,    15,    16,   639,   238,   641,   266,   267,
     265,   243,   261,   135,   136,   261,   583,   896,   897,   898,
     899,   781,   782,   783,   146,   147,   148,   259,   265,   151,
      16,    17,    18,    95,    96,    17,    11,   265,    13,    14,
     674,    16,    17,    18,   678,   265,    17,    18,   766,    18,
      25,    26,    61,    28,   263,    30,    80,    81,   263,   179,
     180,   181,   182,   183,   184,   185,   186,    38,    16,    17,
      18,   726,   236,   237,   262,   263,   100,   822,   102,   103,
      18,   266,   261,   262,   265,   205,   206,   207,    63,   195,
     269,   321,   322,   838,     6,     7,     8,     9,    10,   520,
     521,   522,   178,     6,     7,     8,     9,    10,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    97,    98,   123,   763,
      92,   160,   147,   148,    55,   163,   151,   257,   258,   261,
     155,   263,    55,   161,   139,   175,   169,   269,   173,   189,
     145,   193,   197,   263,   721,   722,   723,   152,   153,   263,
     135,   136,   199,   265,   265,   732,     6,     7,     8,     9,
      10,   146,   147,   148,   266,    59,   151,   263,   265,   203,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    18,
      55,    55,   265,   827,     6,     7,     8,     9,    10,   263,
     263,    59,    55,    18,   265,   265,   263,   263,    20,    21,
      22,    23,    24,    25,    26,    27,    28,   263,    55,   263,
      72,     3,   263,     3,   263,   917,     3,   919,    80,    81,
     263,   263,     3,   800,     3,   259,     3,   804,   805,     3,
       3,     3,   809,     3,   263,   261,   263,    12,   882,   883,
     884,   906,   886,   105,   106,   107,   108,   891,     6,     7,
       8,     9,    10,    13,    25,    55,    13,    26,    24,    55,
      28,   963,    20,    21,    22,    23,    24,    25,    26,    27,
      28,   160,   263,   850,   918,   852,   261,   263,   202,    44,
     167,   925,   926,   263,   269,     6,     7,     8,     9,    10,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    55,    55,
     170,  1013,    55,    61,   263,   265,   263,    17,   962,   263,
     964,   965,   966,   263,   968,   969,   263,   263,   263,   973,
     907,   908,    74,   910,    76,    74,    78,   263,    80,     3,
      82,   263,   263,    85,    86,   121,   122,   123,   124,   125,
     263,   127,   128,   129,   130,   263,  1021,   263,   263,  1003,
      17,  1005,     6,     7,     8,     9,    10,    17,    17,   265,
      18,  1015,   263,   263,   267,   263,    20,    21,    22,    23,
      24,    25,    26,    27,    28,     6,     7,     8,     9,    10,
     262,    24,    16,    13,   261,    26,   267,   263,   263,    20,
      21,    22,    23,    24,    25,    26,    27,    28,     6,     7,
       8,     9,    10,   263,   263,   263,   993,   994,   995,   263,
     263,   263,    20,    21,    22,    23,    24,    25,    26,    27,
      28,     6,     7,     8,     9,    10,   263,   263,   266,   263,
     263,   263,   263,   263,   263,    20,    21,    22,    23,    24,
      25,    26,    27,    28,     6,     7,     8,     9,    10,   263,
     265,   263,   265,     6,     7,     8,     9,    10,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    20,    21,    22,
      23,    24,    25,    26,    27,    28,   262,     3,   266,   230,
       3,     6,     7,     8,     9,    10,     5,     3,     3,   263,
     263,   263,   263,    13,   262,    20,    21,    22,    23,    24,
      25,    26,    27,    28,     6,     7,     8,     9,    10,    13,
      14,   265,    16,    17,    20,   263,   263,   267,    20,    21,
      22,    23,    24,    25,    26,    27,    28,   267,   263,   263,
     263,   262,     6,     7,     8,     9,    10,   263,    17,   263,
      44,   263,   263,   263,   261,    18,    20,    21,    22,    23,
      24,    25,    26,    27,    28,   266,    75,   263,   262,    63,
      13,   263,    62,   263,   263,    44,   263,   262,    68,    20,
      39,   267,   263,    73,   266,    75,    39,    77,   263,    79,
     175,    81,    17,   263,    63,   263,   263,   263,   133,   262,
      59,    60,   264,   264,    63,    64,    59,    60,    67,    68,
      63,    64,   266,   265,    67,    68,   261,   263,   262,    44,
     114,   115,   116,   117,   118,   119,   120,   261,   137,   138,
     175,   140,   141,   142,   143,   144,    95,   131,    63,   133,
     134,   262,    95,   261,   218,   114,   115,   116,   117,   118,
     119,   120,   232,    71,    72,    73,   263,   263,   266,   263,
      78,    79,   131,    81,   262,   134,   263,   263,   263,   705,
     179,   180,   181,   182,   183,   184,   185,   186,   513,    92,
     177,   690,   735,   776,   306,   709,   273,   262,   987,   114,
     115,   116,   117,   118,   119,   120,   205,   206,   207,   509,
      39,   562,    39,   726,  1021,   591,   131,    44,   807,   134,
     262,   910,   718,   851,    -1,    -1,    -1,    -1,    -1,   262,
      59,    60,    59,    60,    63,    64,    63,    64,    67,    68,
      67,    68,    -1,    -1,    -1,    -1,    -1,    74,    -1,    76,
      -1,    -1,    -1,    -1,    -1,   204,    -1,   262,   257,   258,
     209,    -1,   211,    -1,    -1,    39,    95,    -1,    95,    -1,
      -1,    74,    -1,   102,    -1,   102,    -1,   261,    -1,    -1,
     262,    -1,   266,   110,   111,    59,    60,    -1,    -1,    63,
      64,    94,    66,    67,    68,    74,   239,   240,    -1,    -1,
      74,    -1,    -1,    -1,   107,    -1,    -1,   266,   262,    -1,
      -1,    -1,    -1,    -1,   141,    94,    -1,   266,    -1,    93,
      94,    95,    -1,   266,    -1,    -1,    -1,    -1,    39,    -1,
      -1,   158,   159,    -1,   161,   162,    -1,   164,   165,   166,
      -1,   168,    -1,    -1,   171,   172,    -1,   174,    59,    60,
     265,    -1,    63,    64,    17,    66,    67,    68,    -1,    -1,
     187,   188,    -1,    -1,    -1,   192,    -1,   194,    -1,   196,
      -1,   198,    -1,    -1,   177,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    95,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    24,    25,    26,    27,    28,   177,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   210,    -1,   212,
     213,   214,   215,   216,   217,    -1,    -1,   220,     3,   222,
     223,    -1,    -1,   226,    -1,    -1,    -1,    -1,   231,    -1,
      -1,    16,    17,    -1,   213,   214,   215,   266,   217,   266,
      -1,    -1,    -1,   222,    -1,    -1,    -1,    -1,   222,    -1,
      -1,    -1,    -1,    38,    -1,    -1,    -1,    39,   121,   122,
     123,   124,   125,   266,   127,   128,   129,   130,    50,    51,
     244,   245,   246,   247,    59,    -1,    -1,    62,    -1,    -1,
     254,    -1,    -1,    68,    69,    -1,    -1,   266,    -1,    -1,
      -1,    -1,   266,    -1,    -1,    -1,    -1,    82,    83,    84,
      85,   132,    87,   121,   122,   123,   124,   125,    -1,   127,
     128,   129,   130,    -1,    96,    -1,    -1,    99,    -1,    -1,
      -1,    -1,   104,    -1,    -1,    -1,    -1,   109,   110,   111,
     112,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,   266,    -1,    -1,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   156,    20,    21,    22,    23,    24,    25,    26,    27,
      28
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   272,   273,    39,    50,    51,    96,    99,   104,
     109,   110,   111,   112,   288,   289,   290,   326,   327,   328,
     330,   331,   332,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   346,   347,   348,   349,   350,   351,   352,   427,
     428,   429,   430,   431,   447,   449,     0,     3,    31,    36,
      39,    59,    60,    62,    69,    89,   113,   157,   263,   275,
     283,   292,   294,   297,   299,   302,   303,   308,   314,   315,
     354,   356,   366,   396,   397,   398,   399,   432,   433,   434,
     435,   443,   444,   448,   450,   451,   452,    17,    18,    38,
     353,    18,    49,   291,     3,    97,    98,   353,    80,    81,
     100,   102,   103,   203,   259,    72,    80,    81,   105,   106,
     107,   108,    13,    33,    38,   344,   353,   353,   353,    17,
      18,    37,    48,   284,    80,    86,    17,    61,    17,    90,
      17,    11,    13,    14,    16,    17,    18,    25,    26,    28,
      30,    63,   135,   136,   146,   147,   148,   151,   261,   269,
     371,   375,   380,   383,   384,   385,   387,   389,    17,   304,
     304,    52,    57,    65,    90,   203,   238,   243,   259,   304,
      39,    59,    60,    63,    64,    66,    67,    68,    95,   266,
     305,   317,   304,    44,    74,    76,   102,   110,   111,   141,
     158,   159,   161,   162,   164,   165,   166,   168,   171,   172,
     174,   187,   188,   192,   194,   196,   198,   266,   305,   304,
     204,   209,   211,   266,   305,   400,   401,   402,   304,   239,
     240,   266,   305,   304,    66,    74,    93,    94,   222,   244,
     245,   246,   247,   254,   266,   305,   321,   323,   324,   304,
     102,   266,   305,   445,   446,    52,    53,    54,    56,   266,
     293,   296,   305,    54,    82,   266,   295,   305,    33,    38,
     265,   318,   291,     3,   353,   353,     3,    17,    38,   329,
       3,   101,     3,   333,   329,    66,   107,   236,   237,   329,
     329,     3,     3,     3,     3,     3,     3,     3,    13,   345,
       3,     3,     3,    20,    38,   265,   285,   318,    13,    17,
     261,   274,    13,    15,    16,   298,   355,   300,   367,    13,
      17,    27,   261,   268,   379,   381,   387,    28,   261,   155,
     155,    13,   268,   382,   389,   261,   261,   261,   261,   389,
      13,    14,   261,   370,   371,   372,   373,   374,   375,   376,
     377,     5,    75,   137,   138,   140,   141,   142,   143,   144,
     179,   180,   181,   182,   183,   184,   185,   186,   205,   206,
     207,   257,   258,   388,   453,     6,     7,     8,     9,    10,
      20,    21,    22,    23,    24,    25,    26,    27,    28,   265,
     265,   265,   318,    17,   307,    61,   274,    32,    33,    34,
      35,   274,   276,   316,    38,    69,    70,   156,   306,   363,
     306,    18,   263,   263,   265,   176,   177,    18,   276,   195,
     178,   102,   191,    92,   160,    16,    17,   277,    55,   163,
      55,   274,   161,   169,   180,   181,   173,   175,   189,   190,
     189,   193,   276,   197,   199,   263,   265,   298,   276,   274,
     263,   403,   266,   265,    59,   241,   242,   263,   265,   441,
     442,    18,   274,   265,    70,   252,   253,   436,   274,   274,
      55,    55,   159,   255,   256,   263,   263,   265,   265,   277,
     278,   263,   119,   167,   200,   260,   263,    59,   276,    55,
     276,   263,   263,   263,    55,    18,   282,   263,   263,    71,
      72,    73,    78,    79,    81,   319,   320,     3,     3,     3,
       3,   329,     3,     3,     3,    38,    59,    62,    68,    69,
      82,    83,    84,    85,    87,   278,   334,   363,     3,   329,
     329,   329,   329,     3,     3,     3,    16,   274,    39,    40,
      41,    42,    43,    44,    45,    46,    47,   286,   287,   263,
     389,   263,   121,   122,   123,   124,   125,   127,   128,   129,
     130,   357,   358,   359,   361,   365,    91,    92,    93,   263,
     301,   261,   364,   381,   381,   389,   381,   381,    12,    13,
     389,   393,   394,    25,    26,   382,   382,    28,   389,   389,
     389,   389,   262,   267,    13,    24,   267,   270,    25,    26,
     265,   267,   270,   389,   389,   389,   389,   389,   389,   389,
     389,   389,   123,   139,   145,   152,   153,   389,   389,   389,
     389,   298,   309,   312,   313,    17,   361,   362,   389,    55,
      55,   263,   263,   274,    44,   202,   276,   277,   274,   160,
     274,    55,   274,   167,    55,   170,   274,   274,   276,    55,
     263,    61,   263,   276,   263,   276,   170,   200,   201,   265,
      66,   210,   227,   229,   235,   404,   409,   412,    17,   263,
     263,   313,   263,   263,   322,   323,   263,   263,   263,   274,
     274,   263,   263,   263,    61,    88,   118,   325,    28,   264,
     280,    18,   277,   274,   274,   274,   277,   278,   279,   266,
     267,     3,    17,    17,   362,   279,    17,    18,   426,   426,
     426,   426,   263,   263,   266,   267,   262,    17,   126,   263,
     265,   277,   274,   262,   358,   360,   365,   262,   267,   262,
     262,   267,   267,   267,   389,   267,    24,    16,   373,    13,
      16,   376,   261,    26,   311,   267,   274,   274,   263,   276,
     276,   263,   263,   263,   274,   263,   274,   263,   277,   274,
     263,   263,   263,   263,   274,   274,   263,   263,   263,   263,
     263,   422,   425,   212,   276,   265,   230,   278,   405,   406,
     263,   265,   263,   265,   440,   266,   263,   263,   263,   274,
      75,    77,    75,    77,   266,   274,   277,   320,     3,     3,
       3,     3,   287,   359,    17,    44,    63,   114,   115,   116,
     117,   118,   119,   120,   131,   134,   368,   385,   386,   390,
     395,   262,   263,   393,   389,   389,   389,   262,    13,   372,
     267,   389,    18,   278,   310,   312,   263,   267,   263,   263,
     263,   263,   263,   263,   263,   263,   313,   274,   414,   298,
     265,   410,   439,   322,   263,    18,   281,   281,   281,   281,
      20,   261,    20,   261,   389,   389,   389,   266,   388,   453,
     263,   389,   391,   392,   368,   358,   262,   262,   262,   262,
      13,   262,   278,   274,   265,   424,   266,   278,   415,   416,
     417,   407,   177,   213,   214,   215,   217,   222,   266,   321,
     411,   173,   240,   266,   438,   325,   263,   263,   263,   263,
     389,   394,   389,   385,   263,   132,   265,    20,    20,    24,
     267,   263,   266,   263,   423,   228,   263,   101,   212,   228,
     266,   408,   274,   274,   274,   175,    84,   274,    70,   221,
     224,   263,   274,   208,   248,   249,   250,   251,   437,   263,
     325,   325,   325,   325,   263,   262,   263,   453,   265,   369,
     395,   133,   373,   378,   389,   389,   147,   148,   151,   155,
     392,   107,   177,   210,   212,   213,   214,   215,   216,   217,
     220,   222,   223,   226,   231,   266,   321,   413,   263,   276,
     274,   276,   263,   274,   274,   262,   368,   133,   264,   264,
     266,   263,   263,   261,   261,   261,   263,   265,   274,   276,
     274,   274,   274,   175,   274,    84,   274,   208,   218,   219,
      70,   221,   224,   218,   274,   232,   263,   263,   266,   369,
     368,   368,   389,   389,   389,   418,   274,   274,   276,   233,
     234,   274,   378,   262,   262,   262,    16,   266,   419,   420,
     421,   263,   263,   263,   225,   263,   263
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 294 "cf-parse.y"
    { return 0; ;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 295 "cf-parse.y"
    { return 0; ;}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 308 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); ;}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 309 "cf-parse.y"
    { if ((yyvsp[(1) - (1)].s)->class != SYM_NUMBER) cf_error("Number expected"); else (yyval.i) = (yyvsp[(1) - (1)].s)->aux; ;}
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 313 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_NUMBER, NULL);
     (yyvsp[(2) - (5)].s)->aux = (yyvsp[(4) - (5)].i);
   ;}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 317 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_IPA, cfg_alloc(sizeof(ip_addr)));
     *(ip_addr *)(yyvsp[(2) - (5)].s)->def = (yyvsp[(4) - (5)].a);
   ;}
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 326 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); ;}
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 327 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 328 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 329 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 330 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 331 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 338 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_IPA) cf_error("IP address expected");
     (yyval.a) = *(ip_addr *)(yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 345 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 353 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; ;}
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 357 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 361 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   ;}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 368 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   ;}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 376 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); ;}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 377 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 383 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  ;}
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 392 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   ;}
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 397 "cf-parse.y"
    { (yyval.g) = NULL; ;}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 398 "cf-parse.y"
    { (yyval.g) = stderr; ;}
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 402 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 403 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 407 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); ;}
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 408 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); ;}
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 412 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; ;}
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 413 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; ;}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 414 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; ;}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 415 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; ;}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 416 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; ;}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 417 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; ;}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 418 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; ;}
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 419 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; ;}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 420 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; ;}
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 428 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (3)].t), RECONFIG_HARD); ;}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 431 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (4)].t), RECONFIG_SOFT); ;}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 434 "cf-parse.y"
    { cli_msg(7, "Shutdown requested"); order_shutdown(); ;}
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 437 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 446 "cf-parse.y"
    {
#ifndef CONFIG_MULTIPLE_TABLES
     if (cf_krt)
       cf_error("Kernel protocol already defined");
#endif
     cf_krt = this_proto = proto_config_new(&proto_unix_kernel, sizeof(struct krt_config));
     this_proto->preference = DEF_PREF_INHERITED;
     THIS_KRT->scan_time = 60;
     THIS_KRT->learn = THIS_KRT->persist = 0;
     krt_scan_construct(THIS_KRT);
     krt_set_construct(THIS_KRT);
   ;}
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 462 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); ;}
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 463 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 467 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   ;}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 479 "cf-parse.y"
    {
     if (cf_kif)
       cf_error("Kernel device protocol already defined");
     cf_kif = this_proto = proto_config_new(&proto_unix_iface, sizeof(struct kif_config));
     this_proto->preference = DEF_PREF_DIRECT;
     THIS_KIF->scan_time = 60;
     init_list(&THIS_KIF->primary);
     krt_if_construct(THIS_KIF);
   ;}
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 492 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 496 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   ;}
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 509 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->scan.table_id = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 521 "cf-parse.y"
    {
   new_config->router_id = (yyvsp[(3) - (4)].i32);
   ;}
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 527 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); ;}
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 529 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   ;}
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 548 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); ;}
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 549 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); ;}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 550 "cf-parse.y"
    { new_config->listen_bgp_flags |= SKF_V6ONLY; ;}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 557 "cf-parse.y"
    {
   rt_new_table((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 569 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = SYM_PROTO;
     s->def = this_proto;
     this_proto->name = s->name;
     ;}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 575 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), SYM_PROTO, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   ;}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 583 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   ;}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 587 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); ;}
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 588 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); ;}
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 589 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 590 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); ;}
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 591 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); ;}
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 592 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); ;}
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 593 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); ;}
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 597 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); ;}
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 599 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; ;}
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 600 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; ;}
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 604 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 612 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 613 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 619 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   ;}
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 627 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; ;}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 628 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; ;}
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 629 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; ;}
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 633 "cf-parse.y"
    { this_ipn->positive = 1; ;}
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 634 "cf-parse.y"
    { this_ipn->positive = 0; ;}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 651 "cf-parse.y"
    {
     struct rt_dev_config *p = proto_config_new(&proto_device, sizeof(struct rt_dev_config));
     this_proto = &p->c;
     p->c.preference = DEF_PREF_DIRECT;
     init_list(&p->iface_list);
   ;}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 666 "cf-parse.y"
    {
     struct rt_dev_config *p = (void *) this_proto;
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&p->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   ;}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 681 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 682 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 683 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); ;}
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 688 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); ;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 692 "cf-parse.y"
    { (yyval.i) = D_STATES; ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 693 "cf-parse.y"
    { (yyval.i) = D_ROUTES; ;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 694 "cf-parse.y"
    { (yyval.i) = D_FILTERS; ;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 695 "cf-parse.y"
    { (yyval.i) = D_IFACES; ;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 696 "cf-parse.y"
    { (yyval.i) = D_EVENTS; ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 697 "cf-parse.y"
    { (yyval.i) = D_PACKETS; ;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 718 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   ;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 736 "cf-parse.y"
    { ;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 737 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 738 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); ;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 739 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); ;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 740 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); ;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 741 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); ;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 750 "cf-parse.y"
    { cmd_show_status(); ;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 753 "cf-parse.y"
    { proto_show((yyvsp[(3) - (4)].s), 0); ;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 756 "cf-parse.y"
    { proto_show((yyvsp[(4) - (5)].s), 1); ;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 760 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 764 "cf-parse.y"
    { if_show(); ;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 767 "cf-parse.y"
    { if_show_summary(); ;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 770 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); ;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 773 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
     (yyval.ra)->table = config->master_rtc->table;
   ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 779 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   ;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 785 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   ;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 792 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   ;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 797 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   ;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 802 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   ;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 807 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   ;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 811 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 815 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 825 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 833 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   ;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 837 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 844 "cf-parse.y"
    { (yyval.i) = 1; ;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 845 "cf-parse.y"
    { (yyval.i) = 2; ;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 849 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].s)); ;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 853 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); ;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 855 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); ;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 857 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); ;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 859 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); ;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 861 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 863 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 865 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); ;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 867 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 873 "cf-parse.y"
    { (yyval.i) = ~0; ;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 874 "cf-parse.y"
    { (yyval.i) = 0; ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 879 "cf-parse.y"
    { (yyval.i) = 4096; ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 880 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 887 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), XX_DISABLE); ;}
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 889 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), XX_ENABLE); ;}
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 891 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), XX_RESTART); ;}
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 893 "cf-parse.y"
    { proto_xxable((yyvsp[(2) - (3)].t), XX_RELOAD); ;}
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 895 "cf-parse.y"
    { proto_xxable((yyvsp[(3) - (4)].t), XX_RELOAD_IN); ;}
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 897 "cf-parse.y"
    { proto_xxable((yyvsp[(3) - (4)].t), XX_RELOAD_OUT); ;}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 901 "cf-parse.y"
    { proto_debug((yyvsp[(2) - (4)].t), (yyvsp[(3) - (4)].i)); ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 905 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].s)->name; ;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 906 "cf-parse.y"
    { (yyval.t) = "*"; ;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 913 "cf-parse.y"
    { cf_push_scope( (yyvsp[(2) - (2)].s) ); ;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 913 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s) = cf_define_symbol((yyvsp[(2) - (4)].s), SYM_FILTER, (yyvsp[(4) - (4)].f));
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   ;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 922 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); ;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 926 "cf-parse.y"
    { (yyval.i) = T_INT; ;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 927 "cf-parse.y"
    { (yyval.i) = T_BOOL; ;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 928 "cf-parse.y"
    { (yyval.i) = T_IP; ;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 929 "cf-parse.y"
    { (yyval.i) = T_PREFIX; ;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 930 "cf-parse.y"
    { (yyval.i) = T_PAIR; ;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 931 "cf-parse.y"
    { (yyval.i) = T_STRING; ;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 932 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; ;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 933 "cf-parse.y"
    { (yyval.i) = T_PATH; ;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 934 "cf-parse.y"
    { (yyval.i) = T_CLIST; ;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 935 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_IP:
	  case T_PAIR:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   ;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 954 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val)); 
     val->type = (yyvsp[(1) - (2)].i); 
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   ;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 965 "cf-parse.y"
    { (yyval.s) = NULL; ;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 966 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 973 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); ;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 974 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 981 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 990 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 998 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1022 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1023 "cf-parse.y"
    { (yyval.s)=NULL; ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1027 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1033 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1036 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1046 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1047 "cf-parse.y"
    {
     if ((yyvsp[(1) - (2)].x)) {
       if ((yyvsp[(1) - (2)].x)->next)
	 bug("Command has next already set");
       (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x);
       (yyval.x) = (yyvsp[(1) - (2)].x);
     } else (yyval.x) = (yyvsp[(2) - (2)].x);
   ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1058 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   ;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1061 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   ;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1070 "cf-parse.y"
    { (yyval.i) = make_pair((yyvsp[(2) - (5)].i), (yyvsp[(4) - (5)].i)); ;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1077 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); ;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1081 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1082 "cf-parse.y"
    { (yyval.v).type = T_PAIR; (yyval.v).val.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1083 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1084 "cf-parse.y"
    {  (yyval.v).type = (yyvsp[(1) - (1)].i) >> 16; (yyval.v).val.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1088 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (1)].v); 
	(yyval.e)->to = (yyvsp[(1) - (1)].v);
   ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1093 "cf-parse.y"
    { 
	(yyval.e) = f_new_tree(); 
	(yyval.e)->from = (yyvsp[(1) - (4)].v); 
	(yyval.e)->to = (yyvsp[(4) - (4)].v); 
   ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1101 "cf-parse.y"
    { (yyval.e) = (yyvsp[(1) - (1)].e); ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1102 "cf-parse.y"
    { (yyval.e) = (yyvsp[(3) - (3)].e); (yyval.e)->left = (yyvsp[(1) - (3)].e); ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1106 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   ;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1113 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); ;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1114 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; ;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1115 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; ;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1116 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   ;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1123 "cf-parse.y"
    { (yyval.trie) = f_new_trie(); trie_add_prefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1124 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_prefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1127 "cf-parse.y"
    { (yyval.e) = NULL; ;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1128 "cf-parse.y"
    {
     (yyval.e) = (yyvsp[(1) - (4)].e);
     (yyval.e)->data = (yyvsp[(3) - (4)].x);
     (yyval.e)->left = (yyvsp[(4) - (4)].e);
   ;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1133 "cf-parse.y"
    {
     (yyval.e) = f_new_tree(); 
     (yyval.e)->from.type = T_VOID; 
     (yyval.e)->to.type = T_VOID;
     (yyval.e)->data = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1144 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1145 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1149 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1150 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1154 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1155 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1156 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1157 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); ;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1158 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1162 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); ;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1163 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; ;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1164 "cf-parse.y"
    { (yyval.h) = NULL; ;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1168 "cf-parse.y"
    {
        if (((yyvsp[(2) - (5)].x)->code == 'c') && ((yyvsp[(4) - (5)].x)->code == 'c'))
          { 
            if (((yyvsp[(2) - (5)].x)->aux != T_INT) || ((yyvsp[(4) - (5)].x)->aux != T_INT))
              cf_error( "Can't operate with value of non-integer type in pair constructor" );
            (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PAIR;  (yyval.x)->a2.i = make_pair((yyvsp[(2) - (5)].x)->a2.i, (yyvsp[(4) - (5)].x)->a2.i);
          }
	else
	  { (yyval.x) = f_new_inst(); (yyval.x)->code = P('m', 'p'); (yyval.x)->a1.p = (yyvsp[(2) - (5)].x); (yyval.x)->a2.p = (yyvsp[(4) - (5)].x); }
    ;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1181 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); ;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1182 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  ;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1183 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  ;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1184 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1185 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1186 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); ;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1187 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); ;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1188 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); ;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1189 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; ;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1190 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; ;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1204 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1227 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     switch ((yyvsp[(1) - (1)].s)->class) {
       case SYM_NUMBER:
	(yyval.x) = f_new_inst();
	(yyval.x)->code = 'c'; 
	(yyval.x)->aux = T_INT; 
	(yyval.x)->a2.i = (yyvsp[(1) - (1)].s)->aux;
	break;
       case SYM_IPA:
	{ NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; val->type = T_IP; val->val.px.ip = * (ip_addr *) ((yyvsp[(1) - (1)].s)->def); }
	break;
       case SYM_VARIABLE | T_BOOL:
       case SYM_VARIABLE | T_INT:
       case SYM_VARIABLE | T_PAIR:
       case SYM_VARIABLE | T_STRING:
       case SYM_VARIABLE | T_IP:
       case SYM_VARIABLE | T_PREFIX:
       case SYM_VARIABLE | T_PREFIX_SET:
       case SYM_VARIABLE | T_SET:
       case SYM_VARIABLE | T_PATH:
       case SYM_VARIABLE | T_PATH_MASK:
       case SYM_VARIABLE | T_CLIST:
	 (yyval.x)->code = 'V';
	 (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
	 (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
	 break;
       default:
	 cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name );
     }
   ;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1260 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, from);   (yyval.x)->a1.i = 1; ;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1262 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = OFFSETOF(struct rta, gw);     (yyval.x)->a1.i = 1; ;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1263 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = 0x12345678; /* This is actually ok - T_PREFIX is special-cased. */ ;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1264 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = 0x12345678; /* T_STRING is also special-cased. */ ;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1265 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = OFFSETOF(struct rta, source); ;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1266 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = OFFSETOF(struct rta, scope);  (yyval.x)->a1.i = 1; ;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1267 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = OFFSETOF(struct rta, cast); ;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1268 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = OFFSETOF(struct rta, dest); ;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1272 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); ;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1273 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1274 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1275 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1276 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1277 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1278 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1279 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1280 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1281 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1282 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1283 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1284 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1285 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); ;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1286 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); ;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1287 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); ;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1289 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1290 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1291 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1293 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; ;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1295 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; ;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1297 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1299 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1300 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1301 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1302 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1303 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1313 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1314 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1315 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1316 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1317 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1322 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1345 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; ;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1346 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; ;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1347 "cf-parse.y"
    { (yyval.i) = F_REJECT; ;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1348 "cf-parse.y"
    { (yyval.i) = F_ERROR; ;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1349 "cf-parse.y"
    { (yyval.i) = F_NOP; ;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1350 "cf-parse.y"
    { (yyval.i) = F_NONL; ;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 1354 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; ;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 1357 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 1358 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 1359 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 1368 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 1375 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 1384 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 1385 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 1389 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 1395 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 1405 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 1414 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   ;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 1420 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 1425 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   ;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 1432 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   ;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 1437 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   ;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 1443 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); ;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 1444 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); ;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 1445 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   ;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 1454 "cf-parse.y"
    { struct f_inst *i = f_new_inst(); i->code = 'E'; i->aux = T_CLIST; (yyval.x) = (yyvsp[(2) - (5)].x); (yyval.x)->code = P('e','S'); (yyval.x)->a1.p = i; ;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 1455 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 1456 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 1457 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); ;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 1463 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config));
     this_proto->preference = DEF_PREF_BGP;
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = bgp_as4_support;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
 ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 1484 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); ;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 1485 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip)) cf_error("Only one neighbor per BGP instance is allowed");

     BGP_CFG->remote_ip = (yyvsp[(3) - (6)].a);
     BGP_CFG->remote_as = (yyvsp[(5) - (6)].i);
   ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 1491 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i); ;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 1492 "cf-parse.y"
    { BGP_CFG->rr_client = 1; ;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 1493 "cf-parse.y"
    { BGP_CFG->rs_client = 1; ;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 1494 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 1495 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 1496 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 1497 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 1498 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (6)].i); BGP_CFG->multihop_via = (yyvsp[(5) - (6)].a); ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 1499 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 1500 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 1501 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; ;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 1502 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; ;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 1503 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 1504 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); ;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 1505 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); ;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 1506 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 1507 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 1508 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 1509 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 1510 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 1511 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 1512 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 1513 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 1514 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 1515 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 1516 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 1517 "cf-parse.y"
    { BGP_CFG->route_limit = (yyvsp[(4) - (5)].i); ;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 1518 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); ;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 1527 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config));
     this_proto->preference = DEF_PREF_OSPF;
     init_list(&OSPF_CFG->area_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 1543 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 1544 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i) ; if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 1548 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (3)].i32);
  this_area->stub = 0;
  init_list(&this_area->patt_list);
  init_list(&this_area->vlink_list);
  init_list(&this_area->net_list);
  init_list(&this_area->stubnet_list);
 ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 1569 "cf-parse.y"
    { this_area->stub = (yyvsp[(3) - (3)].i) ; if((yyvsp[(3) - (3)].i)<=0) cf_error("Stub cost must be greater than zero"); ;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 1570 "cf-parse.y"
    {if((yyvsp[(2) - (2)].i)) { if(!this_area->stub) this_area->stub=DEFAULT_STUB_COST;}else{ this_area->stub=0;};}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 1583 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   ;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 1597 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); ;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 1598 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); ;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 1599 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); ;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 1603 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 1613 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 1614 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 1615 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 1616 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 1617 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 1618 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 1619 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 1620 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 1621 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 1626 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 1647 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); ;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 1648 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 1649 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 1650 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 1651 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 1652 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); ;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 1653 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 1654 "cf-parse.y"
    { OSPF_PATT->dead = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); ;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 1655 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); ;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 1656 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; ;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 1657 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 1658 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 1659 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; ;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 1660 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 1662 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 1663 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 1664 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 1665 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_LARGE ; ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 1666 "cf-parse.y"
    { OSPF_PATT->rxbuf = OSPF_RXBUF_NORMAL ; ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 1667 "cf-parse.y"
    { OSPF_PATT->rxbuf = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i) < OSPF_RXBUF_MINSIZE) cf_error("Buffer size is too small") ; ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 1681 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (2)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (2)].px).len;
 ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 1690 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(&this_area->net_list, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (3)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (3)].px).len;
   this_pref->hidden = 1;
 ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 1709 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (2)].a);
   this_nbma->eligible=0;
 ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 1718 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=1;
 ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 1728 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->dead = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->strictnbma = 0;
  OSPF_PATT->stub = 0;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 1761 "cf-parse.y"
    { finish_iface_config(OSPF_PATT); ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 1766 "cf-parse.y"
    { (yyval.t) = NULL; ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 1771 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); ;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 1774 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 1777 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 1780 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0); ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 1783 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1); ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 1788 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config));
     this_proto->preference = DEF_PREF_PIPE;
     PIPE_CFG->mode = PIPE_OPAQUE;
  ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 1798 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 1803 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 1804 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; ;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 1810 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config));
     rip_init_config(RIP_CFG);
   ;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 1819 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 1820 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 1821 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); ;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 1822 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 1823 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); ;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 1824 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); ;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 1826 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; ;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 1827 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; ;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 1828 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; ;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 1833 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; ;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 1834 "cf-parse.y"
    { (yyval.i)=AT_MD5; ;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 1835 "cf-parse.y"
    { (yyval.i)=AT_NONE; ;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 1840 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; ;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 1841 "cf-parse.y"
    { (yyval.i)=0; ;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 1842 "cf-parse.y"
    { (yyval.i)=IM_QUIET; ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 1843 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; ;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 1844 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 1848 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 1849 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 1863 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
   ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 1879 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config));
     static_init_config((struct static_config *) this_proto);
  ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 1891 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&((struct static_config *) this_proto)->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  ;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 1900 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (3)].a);
   ;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 1904 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&((struct static_config *) this_proto)->iface_routes, &this_srt->n);
   ;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 1910 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; ;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 1911 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; ;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 1912 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; ;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 1916 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); ;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 1924 "cf-parse.y"
    { bgp_check(BGP_CFG); ;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 1924 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); ;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 1927 "cf-parse.y"
    { (yyval.x) = NULL; ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 1928 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 1929 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 1930 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 1931 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 1932 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 1933 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 1934 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); ;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); ;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); ;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 1935 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); ;}
    break;



/* Line 1455 of yacc.c  */
#line 6411 "cf-parse.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1937 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */


